<?php
session_start();
ob_start();
?>
<?php
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // Always modified
header("Cache-Control: private, no-store, no-cache, must-revalidate"); // HTTP/1.1 
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache"); // HTTP/1.0
?>
<?php include "phprptinc/ewrcfg2.php"; ?>
<?php include "phprptinc/ewmysql.php"; ?>
<?php include "phprptinc/ewrfn2.php"; ?>
<?php include "phprptinc/ewrsecu2.php"; ?>
<?php

// Table level constants
define("EW_REPORT_TABLE_VAR", "ExpectedReceiptReport", TRUE);
define("EW_REPORT_TABLE_GROUP_PER_PAGE", "grpperpage", TRUE);
define("EW_REPORT_TABLE_SESSION_GROUP_PER_PAGE", "ExpectedReceiptReport_grpperpage", TRUE);
define("EW_REPORT_TABLE_START_GROUP", "start", TRUE);
define("EW_REPORT_TABLE_SESSION_START_GROUP", "ExpectedReceiptReport_start", TRUE);
define("EW_REPORT_TABLE_SESSION_SEARCH", "ExpectedReceiptReport_search", TRUE);
define("EW_REPORT_TABLE_CHILD_USER_ID", "childuserid", TRUE);
define("EW_REPORT_TABLE_SESSION_CHILD_USER_ID", "ExpectedReceiptReport_childuserid", TRUE);

// Table level SQL
$EW_REPORT_TABLE_SQL_FROM = "tblnccontracts INNER JOIN tblprojects ON (tblnccontracts.ncContractID = tblprojects.ncContractID) INNER JOIN tbllocation ON (tblnccontracts.locationID = tbllocation.locationID) INNER JOIN tblproductgrp ON (tblprojects.productGroupID = tblproductgrp.productID) INNER JOIN tblclient ON (tblprojects.clientID = tblclient.clientID) INNER JOIN tblncmilestone ON (tblnccontracts.ncContractID = tblncmilestone.ncContractID) INNER JOIN tblncbilldetails ON (tblncmilestone.milestoneID = tblncbilldetails.milestoneID)";
$EW_REPORT_TABLE_SQL_SELECT = "SELECT tbllocation.locationName, tblproductgrp.productName, tblclient.clientName, tblncmilestone.milestone, tblprojects.projectName, tblncbilldetails.billAmount, (SELECT if(DATEDIFF(DATE_ADD(tblncbilldetails.billDate, INTERVAL 21 DAY), Now()) < 0, DATE_ADD(tblncbilldetails.billDate, INTERVAL 21 DAY), NULL) AS FIELD_1) AS overDue FROM " . $EW_REPORT_TABLE_SQL_FROM;
$EW_REPORT_TABLE_SQL_WHERE = "(tblncmilestone.expectedAmt <> 0) AND (tblncbilldetails.billAmount <> 0) AND (tblncbilldetails.receivedAmt = 0) AND (tblnccontracts.contractAmt <> 0) AND (tblnccontracts.isActive = 1)";
$EW_REPORT_TABLE_SQL_GROUPBY = "";
$EW_REPORT_TABLE_SQL_HAVING = "";
$EW_REPORT_TABLE_SQL_ORDERBY = "tbllocation.locationName ASC, tblproductgrp.productName ASC, tblclient.clientName ASC, tblprojects.projectName ASC";
$EW_REPORT_TABLE_SQL_USERID_FILTER = "";
$af_locationName = NULL; // Popup filter for locationName
$af_productName = NULL; // Popup filter for productName
$af_clientName = NULL; // Popup filter for clientName
$af_projectName = NULL; // Popup filter for projectName
$af_milestone = NULL; // Popup filter for milestone
$af_billAmount = NULL; // Popup filter for billAmount
$af_overDue = NULL; // Popup filter for overDue
?>
<?php
$sExport = @$_GET["export"]; // Load export request
if ($sExport == "html") {

	// Printer friendly
}
if ($sExport == "excel") {
	header('Content-Type: application/vnd.ms-excel');
	header('Content-Disposition: attachment; filename=' . EW_REPORT_TABLE_VAR .'.xls');
}
if ($sExport == "word") {
	header('Content-Type: application/vnd.ms-word');
	header('Content-Disposition: attachment; filename=' . EW_REPORT_TABLE_VAR .'.doc');
}
?>
<?php

// Initialize common variables
// Paging variables

$nRecCount = 0; // Record count
$nStartGrp = 0; // Start group
$nStopGrp = 0; // Stop group
$nTotalGrps = 0; // Total groups
$nGrpCount = 0; // Group count
$nDisplayGrps = 3; // Groups per page
$nGrpRange = 10;

// Clear field for ext filter
$sClearExtFilter = "";

// Dropdown filters
// Extended filters
// Custom filters

$ewrpt_CustomFilters = array();
?>
<?php
$EW_REPORT_FIELD_LOCATIONNAME_SQL_SELECT = "SELECT DISTINCT tbllocation.locationName FROM " . $EW_REPORT_TABLE_SQL_FROM;
$EW_REPORT_FIELD_LOCATIONNAME_SQL_ORDERBY = "tbllocation.locationName";
$EW_REPORT_FIELD_PRODUCTNAME_SQL_SELECT = "SELECT DISTINCT tblproductgrp.productName FROM " . $EW_REPORT_TABLE_SQL_FROM;
$EW_REPORT_FIELD_PRODUCTNAME_SQL_ORDERBY = "tblproductgrp.productName";
$EW_REPORT_FIELD_CLIENTNAME_SQL_SELECT = "SELECT DISTINCT tblclient.clientName FROM " . $EW_REPORT_TABLE_SQL_FROM;
$EW_REPORT_FIELD_CLIENTNAME_SQL_ORDERBY = "tblclient.clientName";
$EW_REPORT_FIELD_PROJECTNAME_SQL_SELECT = "SELECT DISTINCT tblprojects.projectName FROM " . $EW_REPORT_TABLE_SQL_FROM;
$EW_REPORT_FIELD_PROJECTNAME_SQL_ORDERBY = "tblprojects.projectName";
?>
<?php

// Field variables
$x_locationName = NULL;
$x_productName = NULL;
$x_clientName = NULL;
$x_projectName = NULL;
$x_milestone = NULL;
$x_billAmount = NULL;
$x_overDue = NULL;

// Group variables
$o_locationName = NULL; $g_locationName = NULL; $dg_locationName = NULL; $t_locationName = NULL; $ft_locationName = 200; $gf_locationName = $ft_locationName; $gb_locationName = ""; $gi_locationName = "0"; $rf_locationName = NULL; $rt_locationName = NULL;
$o_productName = NULL; $g_productName = NULL; $dg_productName = NULL; $t_productName = NULL; $ft_productName = 200; $gf_productName = $ft_productName; $gb_productName = ""; $gi_productName = "0"; $rf_productName = NULL; $rt_productName = NULL;
$o_clientName = NULL; $g_clientName = NULL; $dg_clientName = NULL; $t_clientName = NULL; $ft_clientName = 200; $gf_clientName = $ft_clientName; $gb_clientName = ""; $gi_clientName = "0"; $rf_clientName = NULL; $rt_clientName = NULL;
$o_projectName = NULL; $g_projectName = NULL; $dg_projectName = NULL; $t_projectName = NULL; $ft_projectName = 200; $gf_projectName = $ft_projectName; $gb_projectName = ""; $gi_projectName = "0"; $rf_projectName = NULL; $rt_projectName = NULL;

// Detail variables
$o_milestone = NULL; $t_milestone = NULL; $ft_milestone = 200; $rf_milestone = NULL; $rt_milestone = NULL;
$o_billAmount = NULL; $t_billAmount = NULL; $ft_billAmount = 3; $rf_billAmount = NULL; $rt_billAmount = NULL;
$o_overDue = NULL; $t_overDue = NULL; $ft_overDue = 200; $rf_overDue = NULL; $rt_overDue = NULL;
?>
<?php

// Open connection to the database
$conn = ewrpt_Connect();

// Filter
$sFilter = "";

// Aggregate variables
// 1st dimension = no of groups (level 0 used for grand total)
// 2nd dimension = no of fields

$nDtls = 4;
$nGrps = 5;
$val = ewrpt_InitArray($nDtls, 0);
$cnt = ewrpt_Init2DArray($nGrps, $nDtls, 0);
$smry = ewrpt_Init2DArray($nGrps, $nDtls, 0);
$mn = ewrpt_Init2DArray($nGrps, $nDtls, NULL);
$mx = ewrpt_Init2DArray($nGrps, $nDtls, NULL);
$grandsmry = ewrpt_InitArray($nDtls, 0);
$grandmn = ewrpt_InitArray($nDtls, NULL);
$grandmx = ewrpt_InitArray($nDtls, NULL);

// Set up if accumulation required
$col = array(FALSE, FALSE, TRUE, FALSE);

// Set up groups per page dynamically
SetUpDisplayGrps();

// Load default filter values
LoadDefaultFilters();

// Set up popup filter
SetupPopup();

// Extended filter
// No extended filter

$sExtendedFilter = $sFilter;

// Check if filter applied
$bFilterApplied = CheckFilter();

// Build SQL
$sSql = ewrpt_BuildReportSql("", $EW_REPORT_TABLE_SQL_SELECT, $EW_REPORT_TABLE_SQL_WHERE, $EW_REPORT_TABLE_SQL_GROUPBY, $EW_REPORT_TABLE_SQL_HAVING, $EW_REPORT_TABLE_SQL_ORDERBY, "", $sExtendedFilter, @$sSort);

// echo $sSql . "<br />"; // Uncomment to show SQL
// Load recordset

$rs = $conn->Execute($sSql);
$rscnt = ($rs) ? $rs->RecordCount() : 0;

// Detail distinct and selection values
InitReportData($rs);
if ($nDisplayGrps <= 0) // Display all groups
	$nDisplayGrps = $nTotalGrps;
$nStartGrp = 1;

// Set up start position if not export all
if (!(EW_REPORT_EXPORT_ALL && @$sExport <> ""))
	SetUpStartGroup();
?>
<?php include "phprptinc/header.php"; ?>
<?php if (@$sExport == "") { ?>
<?php } ?>
<?php if (@$sExport == "") { ?>
<script src="phprptjs/x/x_core.js" type="text/javascript"></script>
<script src="phprptjs/x/x_event.js" type="text/javascript"></script>
<script src="phprptjs/x/x_drag.js" type="text/javascript"></script>
<script src="phprptjs/popup.js" type="text/javascript"></script>
<script src="phprptjs/ewrptpop.js" type="text/javascript"></script>
<script src="FusionChartsFree/JSClass/FusionCharts.js" type="text/javascript"></script>
<script type="text/javascript">
var EW_REPORT_POPUP_ALL = "(All)";
var EW_REPORT_POPUP_OK = "  OK  ";
var EW_REPORT_POPUP_CANCEL = "Cancel";
var EW_REPORT_POPUP_FROM = "From";
var EW_REPORT_POPUP_TO = "To";
var EW_REPORT_POPUP_PLEASE_SELECT = "Please Select";
var EW_REPORT_POPUP_NO_VALUE = "No value selected!";

// popup fields
<?php $jsdata = ewrpt_GetJsData($val_locationName, $sel_locationName, $ft_locationName) ?>
ewrpt_CreatePopup("ExpectedReceiptReport_locationName", [<?php echo $jsdata ?>]);
<?php $jsdata = ewrpt_GetJsData($val_productName, $sel_productName, $ft_productName) ?>
ewrpt_CreatePopup("ExpectedReceiptReport_productName", [<?php echo $jsdata ?>]);
<?php $jsdata = ewrpt_GetJsData($val_clientName, $sel_clientName, $ft_clientName) ?>
ewrpt_CreatePopup("ExpectedReceiptReport_clientName", [<?php echo $jsdata ?>]);
<?php $jsdata = ewrpt_GetJsData($val_projectName, $sel_projectName, $ft_projectName) ?>
ewrpt_CreatePopup("ExpectedReceiptReport_projectName", [<?php echo $jsdata ?>]);
</script>
<div id="ExpectedReceiptReport_locationName_Popup" class="ewPopup">
<span class="phpreportmaker"></span>
</div>
<div id="ExpectedReceiptReport_productName_Popup" class="ewPopup">
<span class="phpreportmaker"></span>
</div>
<div id="ExpectedReceiptReport_clientName_Popup" class="ewPopup">
<span class="phpreportmaker"></span>
</div>
<div id="ExpectedReceiptReport_projectName_Popup" class="ewPopup">
<span class="phpreportmaker"></span>
</div>
<?php } ?>
<?php if (@$sExport == "") { ?>
<!-- Table Container (Begin) -->
<table id="ewContainer" cellspacing="0" cellpadding="0" border="0">
<!-- Top Container (Begin) -->
<tr><td colspan="3" class="ewPadding"><div id="ewTop" class="phpreportmaker">
<!-- top slot -->
<a name="top"></a>
<?php } ?>
Expected Receipt Report
<?php if (@$sExport == "") { ?>
&nbsp;&nbsp;<a href="ExpectedReceiptReportsmry.php?export=html">Printer Friendly</a>
&nbsp;&nbsp;<a href="ExpectedReceiptReportsmry.php?export=excel">Export to Excel</a>
&nbsp;&nbsp;<a href="ExpectedReceiptReportsmry.php?export=word">Export to Word</a>
<?php if ($bFilterApplied) { ?>
&nbsp;&nbsp;<a href="ExpectedReceiptReportsmry.php?cmd=reset">Reset All Filters</a>
<?php } ?>
<?php } ?>
<br /><br />
<?php if (@$sExport == "") { ?>
</div></td></tr>
<!-- Top Container (End) -->
<tr>
	<!-- Left Container (Begin) -->
	<td valign="top"><div id="ewLeft" class="phpreportmaker">
	<!-- Left slot -->
	</div></td>
	<!-- Left Container (End) -->
	<!-- Center Container - Report (Begin) -->
	<td valign="top" class="ewPadding"><div id="ewCenter" class="phpreportmaker">
	<!-- center slot -->
<?php } ?>
<!-- summary report starts -->
<div id="report_summary">
<?php if (defined("EW_REPORT_SHOW_CURRENT_FILTER")) { ?>
<div id="ewrptFilterList">
<?php ShowFilterList() ?>
</div>
<br />
<?php } ?>
<!-- Report Grid (Begin) -->
<table id="ewReport" class="ewTable">
<?php

// Set the last group to display if not export all
if (EW_REPORT_EXPORT_ALL && @$sExport <> "") {
	$nStopGrp = $nTotalGrps;
} else {
	$nStopGrp = $nStartGrp + $nDisplayGrps - 1;
}

// Stop group <= total number of groups
if (intval($nStopGrp) > intval($nTotalGrps))
	$nStopGrp = $nTotalGrps;
$nRecCount = 0;

// Init summary values
ResetLevelSummary(0);

// Get first row
if ($rscnt > 0) {
	GetRow(1);
	$nGrpCount = 1;
}

// Force show first header
$bShowFirstHeader = TRUE;
while (($rs && !$rs->EOF) || $bShowFirstHeader) {

	// Show header
	if ($bShowFirstHeader) {
?>
	<tr>
		<td valign="bottom" class="ewRptGrpHeader1">
		<?php if ($bShowFirstHeader || ChkLvlBreak(1)) { ?>
		Location 
<?php if (@$sExport == "") { ?>
		<a href="#" onClick="ewrpt_ShowPopup(this.name, 'ExpectedReceiptReport_locationName', false, '<?php echo $rf_locationName; ?>', '<?php echo $rt_locationName; ?>');return false;" name="x_locationName<?php echo $cnt[0][0]; ?>" id="x_locationName<?php echo $cnt[0][0]; ?>"><img src="phprptimages/popup.gif" width="15" height="14" align="texttop" border="0" alt=""></a>
<?php } ?>
		<?php } ?>
		</td>
		<td valign="bottom" class="ewRptGrpHeader2">
		<?php if ($bShowFirstHeader || ChkLvlBreak(2)) { ?>
		Product Name
<?php if (@$sExport == "") { ?>
		<a href="#" onClick="ewrpt_ShowPopup(this.name, 'ExpectedReceiptReport_productName', false, '<?php echo $rf_productName; ?>', '<?php echo $rt_productName; ?>');return false;" name="x_productName<?php echo $cnt[0][0]; ?>" id="x_productName<?php echo $cnt[0][0]; ?>"><img src="phprptimages/popup.gif" width="15" height="14" align="texttop" border="0" alt=""></a>
<?php } ?>
		<?php } ?>
		</td>
		<td valign="bottom" class="ewRptGrpHeader3">
		<?php if ($bShowFirstHeader || ChkLvlBreak(3)) { ?>
		Client Name
<?php if (@$sExport == "") { ?>
		<a href="#" onClick="ewrpt_ShowPopup(this.name, 'ExpectedReceiptReport_clientName', false, '<?php echo $rf_clientName; ?>', '<?php echo $rt_clientName; ?>');return false;" name="x_clientName<?php echo $cnt[0][0]; ?>" id="x_clientName<?php echo $cnt[0][0]; ?>"><img src="phprptimages/popup.gif" width="15" height="14" align="texttop" border="0" alt=""></a>
<?php } ?>
		<?php } ?>
		</td>
		<td valign="bottom" class="ewRptGrpHeader4">
		<?php if ($bShowFirstHeader || ChkLvlBreak(4)) { ?>
		Project Name
<?php if (@$sExport == "") { ?>
		<a href="#" onClick="ewrpt_ShowPopup(this.name, 'ExpectedReceiptReport_projectName', false, '<?php echo $rf_projectName; ?>', '<?php echo $rt_projectName; ?>');return false;" name="x_projectName<?php echo $cnt[0][0]; ?>" id="x_projectName<?php echo $cnt[0][0]; ?>"><img src="phprptimages/popup.gif" width="15" height="14" align="texttop" border="0" alt=""></a>
<?php } ?>
		<?php } ?>
		</td>
		<td valign="bottom" class="ewTableHeader">
		Milestone
		</td>
		<td valign="bottom" class="ewTableHeader">
		Bill Amount
		</td>
		<td valign="bottom" class="ewTableHeader">
		Over Due
		</td>
	</tr>
<?php
		$bShowFirstHeader = FALSE;
	}
	if (intval($nGrpCount) >= intval($nStartGrp) && $nGrpCount <= $nStopGrp) {
		$nRecCount++;

		// Set row color
		$sItemRowClass = " class=\"ewTableRow\"";

		// Display alternate color for rows
		if ($nRecCount % 2 <> 1)
			$sItemRowClass = " class=\"ewTableAltRow\"";

		// Show group values
		$dg_locationName = $x_locationName;
		if ((is_null($x_locationName) && is_null($o_locationName)) ||
			(($x_locationName <> "" && $o_locationName == $dg_locationName) && !ChkLvlBreak(1))) {
			$dg_locationName = "";
		} elseif (is_null($x_locationName)) {
			$dg_locationName = EW_REPORT_NULL_LABEL;
		} elseif ($x_locationName == "") {
			$dg_locationName = EW_REPORT_EMPTY_LABEL;
		}
		$dg_productName = $x_productName;
		if ((is_null($x_productName) && is_null($o_productName)) ||
			(($x_productName <> "" && $o_productName == $dg_productName) && !ChkLvlBreak(2))) {
			$dg_productName = "";
		} elseif (is_null($x_productName)) {
			$dg_productName = EW_REPORT_NULL_LABEL;
		} elseif ($x_productName == "") {
			$dg_productName = EW_REPORT_EMPTY_LABEL;
		}
		$dg_clientName = $x_clientName;
		if ((is_null($x_clientName) && is_null($o_clientName)) ||
			(($x_clientName <> "" && $o_clientName == $dg_clientName) && !ChkLvlBreak(3))) {
			$dg_clientName = "";
		} elseif (is_null($x_clientName)) {
			$dg_clientName = EW_REPORT_NULL_LABEL;
		} elseif ($x_clientName == "") {
			$dg_clientName = EW_REPORT_EMPTY_LABEL;
		}
		$dg_projectName = $x_projectName;
		if ((is_null($x_projectName) && is_null($o_projectName)) ||
			(($x_projectName <> "" && $o_projectName == $dg_projectName) && !ChkLvlBreak(4))) {
			$dg_projectName = "";
		} elseif (is_null($x_projectName)) {
			$dg_projectName = EW_REPORT_NULL_LABEL;
		} elseif ($x_projectName == "") {
			$dg_projectName = EW_REPORT_EMPTY_LABEL;
		}
?>
	<tr<?php echo $sItemRowClass; ?>>
		<td class="ewRptGrpField1">
		<?php $t_locationName = $x_locationName; $x_locationName = $dg_locationName; ?>
<?php echo $x_locationName ?>
		<?php $x_locationName = $t_locationName; ?></td>
		<td class="ewRptGrpField2">
		<?php $t_productName = $x_productName; $x_productName = $dg_productName; ?>
<?php echo $x_productName ?>
		<?php $x_productName = $t_productName; ?></td>
		<td class="ewRptGrpField3">
		<?php $t_clientName = $x_clientName; $x_clientName = $dg_clientName; ?>
<?php echo $x_clientName ?>
		<?php $x_clientName = $t_clientName; ?></td>
		<td class="ewRptGrpField4">
		<?php $t_projectName = $x_projectName; $x_projectName = $dg_projectName; ?>
<?php echo $x_projectName ?>
		<?php $x_projectName = $t_projectName; ?></td>
		<td class="ewRptDtlField">
<?php echo $x_milestone ?>
</td>
		<td class="ewRptDtlField">
<?php echo $x_billAmount ?>
</td>
		<td class="ewRptDtlField">
<?php echo $x_overDue ?>
</td>
	</tr>
<?php

		// Accumulate page summary
		AccumulateSummary();
	}

	// Accumulate grand summary
	AccumulateGrandSummary();

	// Save old group values
	$o_locationName = $x_locationName;
	$o_productName = $x_productName;
	$o_clientName = $x_clientName;
	$o_projectName = $x_projectName;

	// Get next record
	GetRow(2);

	// Show Footers
	if (intval($nGrpCount) >= intval($nStartGrp) && $nGrpCount <= $nStopGrp) {
?>
<?php
		if (ChkLvlBreak(2) && intval(@$cnt[2][0]) > 0) {
?>
	<tr>
		<td class="ewRptGrpField1"></td>
		<td colspan="6" class="ewRptGrpSummary2">Summary for Product Name: <?php $t_productName = $x_productName; $x_productName = $o_productName; ?>
<?php echo $x_productName ?>
<?php $x_productName = $t_productName; ?> (<?php echo ewrpt_FormatNumber($cnt[2][0],0,-2,-2,-2); ?> Detail Records)</td></tr>
	<tr>
		<td class="ewRptGrpField1"></td>
		<td colspan="3" class="ewRptGrpSummary2">SUM</td>
		<td class="ewRptGrpSummary2">&nbsp;</td>
		<td class="ewRptGrpSummary2">
		<?php $t_billAmount = $x_billAmount; ?>
		<?php $x_billAmount = $smry[2][2]; // Load SUM ?>
<?php echo $x_billAmount ?>
		<?php $x_billAmount = $t_billAmount; ?>
		</td>
		<td class="ewRptGrpSummary2">&nbsp;</td>
	</tr>
<?php

			// Reset level 2 summary
			ResetLevelSummary(2);
		}
?>
<?php
		if (ChkLvlBreak(1) && intval(@$cnt[1][0]) > 0) {
?>
	<tr>
		<td colspan="7" class="ewRptGrpSummary1">Summary for Location : <?php $t_locationName = $x_locationName; $x_locationName = $o_locationName; ?>
<?php echo $x_locationName ?>
<?php $x_locationName = $t_locationName; ?> (<?php echo ewrpt_FormatNumber($cnt[1][0],0,-2,-2,-2); ?> Detail Records)</td></tr>
	<tr>
		<td colspan="4" class="ewRptGrpSummary1">SUM</td>
		<td class="ewRptGrpSummary1">&nbsp;</td>
		<td class="ewRptGrpSummary1">
		<?php $t_billAmount = $x_billAmount; ?>
		<?php $x_billAmount = $smry[1][2]; // Load SUM ?>
<?php echo $x_billAmount ?>
		<?php $x_billAmount = $t_billAmount; ?>
		</td>
		<td class="ewRptGrpSummary1">&nbsp;</td>
	</tr>
<?php

			// Reset level 1 summary
			ResetLevelSummary(1);
		}
?>
<?php
	}

	// Increment group count
	if (ChkLvlBreak(1))
		$nGrpCount++;
} // End while
?>
<?php if (intval(@$cnt[0][3]) > 0) { ?>
	<tr class="ewRptPageSummary"><td colspan="7">Page Total (<?php echo ewrpt_FormatNumber($cnt[0][3],0,-2,-2,-2); ?> Detail Records)</td></tr>
	<tr class="ewRptPageSummary">
		<td colspan="4" class="ewRptGrpAggregate">SUM</td>
		<td>&nbsp;</td>
		<td>
		<?php $t_billAmount = $x_billAmount; ?>
		<?php $x_billAmount = $smry[0][2]; // Load SUM ?>
<?php echo $x_billAmount ?>
		<?php $x_billAmount = $t_billAmount ?>
		</td>
		<td>&nbsp;</td>
	</tr>
	<!-- tr class="ewRptPageSummary"><td colspan="7"><span class="phpreportmaker">&nbsp;<br /></span></td></tr -->
<?php } ?>
<?php if ($nTotalGrps > 0) { ?>
	<!-- tr><td colspan="7"><span class="phpreportmaker">&nbsp;<br /></span></td></tr -->
	<tr class="ewRptGrandSummary"><td colspan="7">Grand Total (<?php echo ewrpt_FormatNumber($cnt[0][0],0,-2,-2,-2); ?> Detail Records)</td></tr>
	<tr class="ewRptGrandSummary">
		<td colspan="4" class="ewRptGrpAggregate">SUM</td>
		<td>&nbsp;</td>
		<td>
		<?php $t_billAmount = $x_billAmount; ?>
		<?php $x_billAmount = $grandsmry[2]; // Load SUM ?>
<?php echo $x_billAmount ?>
		<?php $x_billAmount = $t_billAmount; ?>
		</td>
		<td>&nbsp;</td>
	</tr>
<?php } ?>
</table>
<br />
<?php if (@$sExport == "") { ?>
<form action="ExpectedReceiptReportsmry.php" name="ewpagerform" id="ewpagerform">
<table border="0" cellspacing="0" cellpadding="0">
	<tr>
		<td nowrap>
<?php
if ($nTotalGrps > 0) {
	$rsEof = ($nTotalGrps < ($nStartGrp + $nDisplayGrps));
	$PrevStart = $nStartGrp - $nDisplayGrps;
	if ($PrevStart < 1)
		$PrevStart = 1;
	$NextStart = $nStartGrp + $nDisplayGrps;
	if ($NextStart > $nTotalGrps)
		$NextStart = $nStartGrp;
	$LastStart = intval(($nTotalGrps-1)/$nDisplayGrps)*$nDisplayGrps+1;
?>
	<table border="0" cellspacing="0" cellpadding="0"><tr><td><span class="phpreportmaker">Page&nbsp;</span></td>
<!--first page button-->
	<?php if ($nStartGrp == 1) { ?>
	<td><img src="phprptimages/firstdisab.gif" alt="First" width="16" height="16" border="0"></td>
	<?php } else { ?>
	<td><a href="ExpectedReceiptReportsmry.php?start=1"><img src="phprptimages/first.gif" alt="First" width="16" height="16" border="0"></a></td>
	<?php } ?>
<!--previous page button-->
	<?php if ($PrevStart == $nStartGrp) { ?>
	<td><img src="phprptimages/prevdisab.gif" alt="Previous" width="16" height="16" border="0"></td>
	<?php } else { ?>
	<td><a href="ExpectedReceiptReportsmry.php?start=<?php echo $PrevStart; ?>"><img src="phprptimages/prev.gif" alt="Previous" width="16" height="16" border="0"></a></td>
	<?php } ?>
<!--current page number-->
	<td><input type="text" name="pageno" value="<?php echo intval(($nStartGrp-1)/$nDisplayGrps+1); ?>" size="4"></td>
<!--next page button-->
	<?php if ($NextStart == $nStartGrp) { ?>
	<td><img src="phprptimages/nextdisab.gif" alt="Next" width="16" height="16" border="0"></td>
	<?php } else { ?>
	<td><a href="ExpectedReceiptReportsmry.php?start=<?php echo $NextStart; ?>"><img src="phprptimages/next.gif" alt="Next" width="16" height="16" border="0"></a></td>
	<?php  } ?>
<!--last page button-->
	<?php if ($LastStart == $nStartGrp) { ?>
	<td><img src="phprptimages/lastdisab.gif" alt="Last" width="16" height="16" border="0"></td>
	<?php } else { ?>
	<td><a href="ExpectedReceiptReportsmry.php?start=<?php echo $LastStart; ?>"><img src="phprptimages/last.gif" alt="Last" width="16" height="16" border="0"></a></td>
	<?php } ?>
	<td><span class="phpreportmaker">&nbsp;of <?php echo intval(($nTotalGrps-1)/$nDisplayGrps+1);?></span></td>
	</tr></table>
	<?php
	if ($nStartGrp > $nTotalGrps)
		$nStartGrp = $nTotalGrps;
	$nStopGrp = $nStartGrp + $nDisplayGrps - 1;
	$nGrpCount = $nTotalGrps - 1;
	if ($rsEof)
		$nGrpCount = $nTotalGrps;
	if ($nStopGrp > $nGrpCount)
		$nStopGrp = $nGrpCount; ?>
	<span class="phpreportmaker"> <?php echo $nStartGrp; ?> to <?php echo $nStopGrp; ?> of <?php echo $nTotalGrps; ?></span>
<?php } else { ?>
	<?php if ($sExtendedFilter == "0=101") { ?>
	<span class="phpreportmaker">Please enter search criteria</span>
	<?php } else { ?>
	<span class="phpreportmaker">No records found</span>
	<?php } ?>
<?php } ?>
		</td>
<?php if ($nTotalGrps > 0) { ?>
		<td nowrap>&nbsp;&nbsp;&nbsp;&nbsp;</td>
		<td align="right" valign="top" nowrap><span class="phpreportmaker">Groups Per Page&nbsp;
<select name="<?php echo EW_REPORT_TABLE_GROUP_PER_PAGE; ?>" onChange="this.form.submit();" class="phpreportmaker">
<option value="1"<?php if ($nDisplayGrps == 1) echo " selected" ?>>1</option>
<option value="2"<?php if ($nDisplayGrps == 2) echo " selected" ?>>2</option>
<option value="3"<?php if ($nDisplayGrps == 3) echo " selected" ?>>3</option>
<option value="4"<?php if ($nDisplayGrps == 4) echo " selected" ?>>4</option>
<option value="5"<?php if ($nDisplayGrps == 5) echo " selected" ?>>5</option>
<option value="10"<?php if ($nDisplayGrps == 10) echo " selected" ?>>10</option>
<option value="20"<?php if ($nDisplayGrps == 20) echo " selected" ?>>20</option>
<option value="50"<?php if ($nDisplayGrps == 50) echo " selected" ?>>50</option>
<option value="ALL"<?php if (@$_SESSION[EW_REPORT_TABLE_SESSION_GROUP_PER_PAGE] == -1) echo " selected" ?>>All Records</option>
</select>
		</span></td>
<?php } ?>
	</tr>
</table>
</form>
<?php } ?>
</div>
<!-- Summary Report Ends -->
<?php if (@$sExport == "") { ?>
	</div><br /></td>
	<!-- Center Container - Report (End) -->
	<!-- Right Container (Begin) -->
	<td valign="top"><div id="ewRight" class="phpreportmaker">
	<!-- Right slot -->
	</div></td>
	<!-- Right Container (End) -->
</tr>
<!-- Bottom Container (Begin) -->
<tr><td colspan="3"><div id="ewBottom" class="phpreportmaker">
	<!-- Bottom slot -->
	</div><br /></td></tr>
<!-- Bottom Container (End) -->
</table>
<!-- Table Container (End) -->
<?php } ?>
<?php
$conn->Close();
?>
<?php include "phprptinc/footer.php"; ?>
<?php

// Check level break
function ChkLvlBreak($lvl) {
	switch ($lvl) {
		case 1:
			return (is_null($GLOBALS["x_locationName"]) && !is_null($GLOBALS["o_locationName"])) ||
				(!is_null($GLOBALS["x_locationName"]) && is_null($GLOBALS["o_locationName"])) ||
				($GLOBALS["x_locationName"] <> $GLOBALS["o_locationName"]);
		case 2:
			return (is_null($GLOBALS["x_productName"]) && !is_null($GLOBALS["o_productName"])) ||
				(!is_null($GLOBALS["x_productName"]) && is_null($GLOBALS["o_productName"])) ||
				($GLOBALS["x_productName"] <> $GLOBALS["o_productName"]) || ChkLvlBreak(1); // Recurse upper level
		case 3:
			return (is_null($GLOBALS["x_clientName"]) && !is_null($GLOBALS["o_clientName"])) ||
				(!is_null($GLOBALS["x_clientName"]) && is_null($GLOBALS["o_clientName"])) ||
				($GLOBALS["x_clientName"] <> $GLOBALS["o_clientName"]) || ChkLvlBreak(2); // Recurse upper level
		case 4:
			return (is_null($GLOBALS["x_projectName"]) && !is_null($GLOBALS["o_projectName"])) ||
				(!is_null($GLOBALS["x_projectName"]) && is_null($GLOBALS["o_projectName"])) ||
				($GLOBALS["x_projectName"] <> $GLOBALS["o_projectName"]) || ChkLvlBreak(3); // Recurse upper level
	}
}

// Accummulate summary
function AccumulateSummary() {
	global $smry, $cnt, $col, $val, $mn, $mx;
	for ($ix = 0; $ix < count($smry); $ix++) {
		for ($iy = 1; $iy < count($smry[$ix]); $iy++) {
			$cnt[$ix][$iy]++;
			if ($col[$iy]) {
				$valwrk = $val[$iy];
				if (is_null($valwrk) || !is_numeric($valwrk)) {

					// skip
				} else {
					$smry[$ix][$iy] += $valwrk;
					if (is_null($mn[$ix][$iy])) {
						$mn[$ix][$iy] = $valwrk;
						$mx[$ix][$iy] = $valwrk;
					} else {
						if ($mn[$ix][$iy] > $valwrk) $mn[$ix][$iy] = $valwrk;
						if ($mx[$ix][$iy] < $valwrk) $mx[$ix][$iy] = $valwrk;
					}
				}
			}
		}
	}
	for ($ix = 1; $ix < count($smry); $ix++) {
		$cnt[$ix][0]++;
	}
}

// Reset level summary
function ResetLevelSummary($lvl) {
	global $smry, $cnt, $col, $mn, $mx, $nRecCount, $grandsmry;

	// Clear summary values
	for ($ix = $lvl; $ix < count($smry); $ix++) {
		for ($iy = 1; $iy < count($smry[$ix]); $iy++) {
			$cnt[$ix][$iy] = 0;
			if ($col[$iy]) {
				$smry[$ix][$iy] = 0;
				$mn[$ix][$iy] = NULL;
				$mx[$ix][$iy] = NULL;
			}
		}
	}
	for ($ix = $lvl; $ix < count($smry); $ix++) {
		$cnt[$ix][0] = 0;
	}

	// Clear grand summary
	if ($lvl == 0) {
		for ($iy = 1; $iy < count($grandsmry[$iy]); $iy++) {
			if ($col[$iy]) {
				$grandsmry[$iy] = 0;
				$grandmn[$iy] = NULL;
				$grandmx[$iy] = NULL;
			}
		}
	}

	// Clear old values
	if ($lvl <= 1) $GLOBALS["o_locationName"] = "";
	if ($lvl <= 2) $GLOBALS["o_productName"] = "";
	if ($lvl <= 3) $GLOBALS["o_clientName"] = "";
	if ($lvl <= 4) $GLOBALS["o_projectName"] = "";

	// Reset record count
	$nRecCount = 0;
}

// Accummulate grand summary
function AccumulateGrandSummary() {
	global $cnt, $col, $val, $grandsmry, $grandmn, $grandmx;
	@$cnt[0][0]++;
	for ($iy = 1; $iy < count($grandsmry); $iy++) {
		if ($col[$iy]) {
			$valwrk = $val[$iy];
			if (is_null($valwrk) || !is_numeric($valwrk)) {

				// skip
			} else {
				$grandsmry[$iy] += $valwrk;
				if (is_null($grandmn[$iy])) {
					$grandmn[$iy] = $valwrk;
					$grandmx[$iy] = $valwrk;
				} else {
					if ($grandmn[$iy] > $valwrk) $grandmn[$iy] = $valwrk;
					if ($grandmx[$iy] < $valwrk) $grandmx[$iy] = $valwrk;
				}
			}
		}
	}
}

// Get row values
function GetRow($opt) {
	global $rs, $val;
	if (!$rs)
		return;
	if ($opt == 1) { // Get first row
		$rs->MoveFirst();
	} else { // Get next row
		$rs->MoveNext();
	}
	while (!$rs->EOF) {
		if (ValidRow($rs)) {
			$GLOBALS['x_locationName'] = $rs->fields('locationName');
			$GLOBALS['x_productName'] = $rs->fields('productName');
			$GLOBALS['x_clientName'] = $rs->fields('clientName');
			$GLOBALS['x_projectName'] = $rs->fields('projectName');
			$GLOBALS['x_milestone'] = $rs->fields('milestone');
			$GLOBALS['x_billAmount'] = $rs->fields('billAmount');
			$GLOBALS['x_overDue'] = $rs->fields('overDue');
			$val[1] = $GLOBALS['x_milestone'];
			$val[2] = $GLOBALS['x_billAmount'];
			$val[3] = $GLOBALS['x_overDue'];
			break;
		} else {
			$rs->MoveNext();
		}
	}
	if ($rs->EOF) {
		$GLOBALS['x_locationName'] = "";
		$GLOBALS['x_productName'] = "";
		$GLOBALS['x_clientName'] = "";
		$GLOBALS['x_projectName'] = "";
		$GLOBALS['x_milestone'] = "";
		$GLOBALS['x_billAmount'] = "";
		$GLOBALS['x_overDue'] = "";
	}
}

//  Set up starting group
function SetUpStartGroup() {
	global $nStartGrp, $nTotalGrps, $nDisplayGrps;

	// Exit if no groups
	if ($nDisplayGrps == 0)
		return;

	// Check for a 'start' parameter
	if (@$_GET[EW_REPORT_TABLE_START_GROUP] != "") {
		$nStartGrp = $_GET[EW_REPORT_TABLE_START_GROUP];
		$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP] = $nStartGrp;
	} elseif (@$_GET["pageno"] != "") {
		$nPageNo = $_GET["pageno"];
		if (is_numeric($nPageNo)) {
			$nStartGrp = ($nPageNo-1)*$nDisplayGrps+1;
			if ($nStartGrp <= 0) {
				$nStartGrp = 1;
			} elseif ($nStartGrp >= intval(($nTotalGrps-1)/$nDisplayGrps)*$nDisplayGrps+1) {
				$nStartGrp = intval(($nTotalGrps-1)/$nDisplayGrps)*$nDisplayGrps+1;
			}
			$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP] = $nStartGrp;
		} else {
			$nStartGrp = @$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP];
		}
	} else {
		$nStartGrp = @$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP];	
	}

	// Check if correct start group counter
	if (!is_numeric($nStartGrp) || $nStartGrp == "") { // Avoid invalid start group counter
		$nStartGrp = 1; // Reset start group counter
		$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP] = $nStartGrp;
	} elseif (intval($nStartGrp) > intval($nTotalGrps)) { // Avoid starting group > total groups
		$nStartGrp = intval(($nTotalGrps-1)/$nDisplayGrps) * $nDisplayGrps + 1; // Point to last page first group
		$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP] = $nStartGrp;
	} elseif (($nStartGrp-1) % $nDisplayGrps <> 0) {
		$nStartGrp = intval(($nStartGrp-1)/$nDisplayGrps) * $nDisplayGrps + 1; // Point to page boundary
		$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP] = $nStartGrp;
	}
}

// Set up popup
function SetupPopup() {
	global $conn, $sFilter;

	// Initialize popup
	// Build distinct values for locationName

	$bNullValue = FALSE;
	$bEmptyValue = FALSE;
	$sSql = ewrpt_BuildReportSql("", $GLOBALS["EW_REPORT_FIELD_LOCATIONNAME_SQL_SELECT"], $GLOBALS["EW_REPORT_TABLE_SQL_WHERE"], $GLOBALS["EW_REPORT_TABLE_SQL_GROUPBY"], $GLOBALS["EW_REPORT_TABLE_SQL_HAVING"], $GLOBALS["EW_REPORT_FIELD_LOCATIONNAME_SQL_ORDERBY"], "", $sFilter, "");
	$rswrk = $conn->Execute($sSql);
	while ($rswrk && !$rswrk->EOF) {
		$x_locationName = $rswrk->fields[0];
		if (is_null($x_locationName)) {
			$bNullValue = TRUE;
		} elseif ($x_locationName == "") {
			$bEmptyValue = TRUE;
		} else {
			$g_locationName = $x_locationName;
			$dg_locationName = $x_locationName;
			ewrpt_SetupDistinctValues($GLOBALS["val_locationName"], $g_locationName, $dg_locationName, FALSE);
		}
		$rswrk->MoveNext();
	}
	if ($rswrk)
		$rswrk->Close();
	if ($bEmptyValue)
		ewrpt_SetupDistinctValues($GLOBALS["val_locationName"], EW_REPORT_EMPTY_VALUE, EW_REPORT_EMPTY_LABEL, FALSE);
	if ($bNullValue)
		ewrpt_SetupDistinctValues($GLOBALS["val_locationName"], EW_REPORT_NULL_VALUE, EW_REPORT_NULL_LABEL, FALSE);

	// Build distinct values for productName
	$bNullValue = FALSE;
	$bEmptyValue = FALSE;
	$sSql = ewrpt_BuildReportSql("", $GLOBALS["EW_REPORT_FIELD_PRODUCTNAME_SQL_SELECT"], $GLOBALS["EW_REPORT_TABLE_SQL_WHERE"], $GLOBALS["EW_REPORT_TABLE_SQL_GROUPBY"], $GLOBALS["EW_REPORT_TABLE_SQL_HAVING"], $GLOBALS["EW_REPORT_FIELD_PRODUCTNAME_SQL_ORDERBY"], "", $sFilter, "");
	$rswrk = $conn->Execute($sSql);
	while ($rswrk && !$rswrk->EOF) {
		$x_productName = $rswrk->fields[0];
		if (is_null($x_productName)) {
			$bNullValue = TRUE;
		} elseif ($x_productName == "") {
			$bEmptyValue = TRUE;
		} else {
			$g_productName = $x_productName;
			$dg_productName = $x_productName;
			ewrpt_SetupDistinctValues($GLOBALS["val_productName"], $g_productName, $dg_productName, FALSE);
		}
		$rswrk->MoveNext();
	}
	if ($rswrk)
		$rswrk->Close();
	if ($bEmptyValue)
		ewrpt_SetupDistinctValues($GLOBALS["val_productName"], EW_REPORT_EMPTY_VALUE, EW_REPORT_EMPTY_LABEL, FALSE);
	if ($bNullValue)
		ewrpt_SetupDistinctValues($GLOBALS["val_productName"], EW_REPORT_NULL_VALUE, EW_REPORT_NULL_LABEL, FALSE);

	// Build distinct values for clientName
	$bNullValue = FALSE;
	$bEmptyValue = FALSE;
	$sSql = ewrpt_BuildReportSql("", $GLOBALS["EW_REPORT_FIELD_CLIENTNAME_SQL_SELECT"], $GLOBALS["EW_REPORT_TABLE_SQL_WHERE"], $GLOBALS["EW_REPORT_TABLE_SQL_GROUPBY"], $GLOBALS["EW_REPORT_TABLE_SQL_HAVING"], $GLOBALS["EW_REPORT_FIELD_CLIENTNAME_SQL_ORDERBY"], "", $sFilter, "");
	$rswrk = $conn->Execute($sSql);
	while ($rswrk && !$rswrk->EOF) {
		$x_clientName = $rswrk->fields[0];
		if (is_null($x_clientName)) {
			$bNullValue = TRUE;
		} elseif ($x_clientName == "") {
			$bEmptyValue = TRUE;
		} else {
			$g_clientName = $x_clientName;
			$dg_clientName = $x_clientName;
			ewrpt_SetupDistinctValues($GLOBALS["val_clientName"], $g_clientName, $dg_clientName, FALSE);
		}
		$rswrk->MoveNext();
	}
	if ($rswrk)
		$rswrk->Close();
	if ($bEmptyValue)
		ewrpt_SetupDistinctValues($GLOBALS["val_clientName"], EW_REPORT_EMPTY_VALUE, EW_REPORT_EMPTY_LABEL, FALSE);
	if ($bNullValue)
		ewrpt_SetupDistinctValues($GLOBALS["val_clientName"], EW_REPORT_NULL_VALUE, EW_REPORT_NULL_LABEL, FALSE);

	// Build distinct values for projectName
	$bNullValue = FALSE;
	$bEmptyValue = FALSE;
	$sSql = ewrpt_BuildReportSql("", $GLOBALS["EW_REPORT_FIELD_PROJECTNAME_SQL_SELECT"], $GLOBALS["EW_REPORT_TABLE_SQL_WHERE"], $GLOBALS["EW_REPORT_TABLE_SQL_GROUPBY"], $GLOBALS["EW_REPORT_TABLE_SQL_HAVING"], $GLOBALS["EW_REPORT_FIELD_PROJECTNAME_SQL_ORDERBY"], "", $sFilter, "");
	$rswrk = $conn->Execute($sSql);
	while ($rswrk && !$rswrk->EOF) {
		$x_projectName = $rswrk->fields[0];
		if (is_null($x_projectName)) {
			$bNullValue = TRUE;
		} elseif ($x_projectName == "") {
			$bEmptyValue = TRUE;
		} else {
			$g_projectName = $x_projectName;
			$dg_projectName = $x_projectName;
			ewrpt_SetupDistinctValues($GLOBALS["val_projectName"], $g_projectName, $dg_projectName, FALSE);
		}
		$rswrk->MoveNext();
	}
	if ($rswrk)
		$rswrk->Close();
	if ($bEmptyValue)
		ewrpt_SetupDistinctValues($GLOBALS["val_projectName"], EW_REPORT_EMPTY_VALUE, EW_REPORT_EMPTY_LABEL, FALSE);
	if ($bNullValue)
		ewrpt_SetupDistinctValues($GLOBALS["val_projectName"], EW_REPORT_NULL_VALUE, EW_REPORT_NULL_LABEL, FALSE);

	// Process post back form
	if (count($_POST) > 0) {
		$sName = @$_POST["popup"]; // Get popup form name
		if ($sName <> "") {
		$cntValues = (is_array(@$_POST["sel_$sName"])) ? count($_POST["sel_$sName"]) : 0;
			if ($cntValues > 0) {
				$arValues = ewrpt_StripSlashes($_POST["sel_$sName"]);
				if (trim($arValues[0]) == "") // Select all
					$arValues = EW_REPORT_INIT_VALUE;
				$_SESSION["sel_$sName"] = $arValues;
				$_SESSION["rf_$sName"] = ewrpt_StripSlashes(@$_POST["rf_$sName"]);
				$_SESSION["rt_$sName"] = ewrpt_StripSlashes(@$_POST["rt_$sName"]);
				ResetPager();
			}
		}

	// Get 'reset' command
	} elseif (@$_GET["cmd"] <> "") {
		$sCmd = $_GET["cmd"];
		if (strtolower($sCmd) == "reset") {
			ClearSessionSelection('locationName');
			ClearSessionSelection('productName');
			ClearSessionSelection('clientName');
			ClearSessionSelection('projectName');
			ResetPager();
		}
	}

	// Load selection criteria to array
	// Get Location  selected values

	if (is_array(@$_SESSION["sel_ExpectedReceiptReport_locationName"])) {
		LoadSelectionFromSession('locationName');
	} elseif (@$_SESSION["sel_ExpectedReceiptReport_locationName"] == EW_REPORT_INIT_VALUE) { // Select all
		$GLOBALS["sel_locationName"] = "";
	}

	// Get Product Name selected values
	if (is_array(@$_SESSION["sel_ExpectedReceiptReport_productName"])) {
		LoadSelectionFromSession('productName');
	} elseif (@$_SESSION["sel_ExpectedReceiptReport_productName"] == EW_REPORT_INIT_VALUE) { // Select all
		$GLOBALS["sel_productName"] = "";
	}

	// Get Client Name selected values
	if (is_array(@$_SESSION["sel_ExpectedReceiptReport_clientName"])) {
		LoadSelectionFromSession('clientName');
	} elseif (@$_SESSION["sel_ExpectedReceiptReport_clientName"] == EW_REPORT_INIT_VALUE) { // Select all
		$GLOBALS["sel_clientName"] = "";
	}

	// Get Project Name selected values
	if (is_array(@$_SESSION["sel_ExpectedReceiptReport_projectName"])) {
		LoadSelectionFromSession('projectName');
	} elseif (@$_SESSION["sel_ExpectedReceiptReport_projectName"] == EW_REPORT_INIT_VALUE) { // Select all
		$GLOBALS["sel_projectName"] = "";
	}
}

// Reset pager
function ResetPager() {

	// Reset start position (reset command)
	global $nStartGrp, $nTotalGrps;
	$nStartGrp = 1;
	$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP] = $nStartGrp;
}

// Initialize group data - total number of groups + grouping field arrays
function InitReportData(&$rs) {
	global $nTotalGrps;

	// Initialize group count
	$grpcnt = 0;
	while ($rs && !$rs->EOF) {
		$bValidRow = ValidRow($rs);

		// Update group count
		if ($bValidRow) {
			$x_locationName = $rs->fields('locationName');
			$g_locationName = $x_locationName;
			$bNewGroup = ($grpcnt == 0) ||
				(is_null($grpvalue) && !is_null($x_locationName)) ||
				(!is_null($grpvalue) && is_null($x_locationName)) ||
				(@$grpvalue <> $g_locationName);
			if ($bNewGroup) {
				$grpvalue = $g_locationName;
				$grpcnt++;
			}
		}
		$rs->MoveNext();
	}

	// Set up total number of groups
	$nTotalGrps = $grpcnt;
}

// Check if row is valid
function ValidRow(&$rs) {
	if (!ewrpt_SelectedValue($GLOBALS["sel_locationName"], $rs->fields('locationName'), $GLOBALS["ft_locationName"], $GLOBALS["af_locationName"]))
		return FALSE;
	if (!ewrpt_SelectedValue($GLOBALS["sel_productName"], $rs->fields('productName'), $GLOBALS["ft_productName"], $GLOBALS["af_productName"]))
		return FALSE;
	if (!ewrpt_SelectedValue($GLOBALS["sel_clientName"], $rs->fields('clientName'), $GLOBALS["ft_clientName"], $GLOBALS["af_clientName"]))
		return FALSE;
	if (!ewrpt_SelectedValue($GLOBALS["sel_projectName"], $rs->fields('projectName'), $GLOBALS["ft_projectName"], $GLOBALS["af_projectName"]))
		return FALSE;
	return TRUE;
}
?>
<?php

// Set up number of groups displayed per page
function SetUpDisplayGrps() {
	global $nDisplayGrps, $nStartGrp;
	$sWrk = @$_GET[EW_REPORT_TABLE_GROUP_PER_PAGE];
	if ($sWrk <> "") {
		if (is_numeric($sWrk)) {
			$nDisplayGrps = intval($sWrk);
		} else {
			if (strtoupper($sWrk) == "ALL") { // display all groups
				$nDisplayGrps = -1;
			} else {
				$nDisplayGrps = 3; // Non-numeric, load default
			}
		}
		$_SESSION[EW_REPORT_TABLE_SESSION_GROUP_PER_PAGE] = $nDisplayGrps; // Save to session

		// Reset start position (reset command)
		$nStartGrp = 1;
		$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP] = $nStartGrp;
	} else {
		if (@$_SESSION[EW_REPORT_TABLE_SESSION_GROUP_PER_PAGE] <> "") {
			$nDisplayGrps = $_SESSION[EW_REPORT_TABLE_SESSION_GROUP_PER_PAGE]; // Restore from session
		} else {
			$nDisplayGrps = 3; // Load default
		}
	}
}
?>
<?php

// Clear selection stored in session
function ClearSessionSelection($parm) {
	$_SESSION["sel_ExpectedReceiptReport_$parm"] = "";
	$_SESSION["rf_ExpectedReceiptReport_$parm"] = "";
	$_SESSION["rt_ExpectedReceiptReport_$parm"] = "";
}

// Load selection from session
function LoadSelectionFromSession($parm) {
	$GLOBALS["sel_$parm"] = @$_SESSION["sel_ExpectedReceiptReport_$parm"];
	$GLOBALS["rf_$parm"] = @$_SESSION["rf_ExpectedReceiptReport_$parm"];
	$GLOBALS["rt_$parm"] = @$_SESSION["rt_ExpectedReceiptReport_$parm"];
}

// Load default value for filters
function LoadDefaultFilters() {

	/**
	* Set up default values for dropdown filters
	*/

	/**
	* Set up default values for extended filters
	* function SetDefaultExtFilter($parm, $so1, $sv1, $sc, $so2, $sv2)
	* Parameters:
	* $parm - Field name
	* $so1 - Default search operator 1
	* $sv1 - Default ext filter value 1
	* $sc - Default search condition (if operator 2 is enabled)
	* $so2 - Default search operator 2 (if operator 2 is enabled)
	* $sv2 - Default ext filter value 2 (if operator 2 is enabled)
	*/

	/**
	* Set up default values for popup filters
	* NOTE: if extended filter is enabled, use default values in extended filter instead
	*/

	// Field locationName
	// Setup your default values for the extended filter below, e.g.
	// $seld_locationName = array("val1", "val2");

	$GLOBALS["seld_locationName"] = "";
	$GLOBALS["sel_locationName"] =  $GLOBALS["seld_locationName"];

	// Field productName
	// Setup your default values for the extended filter below, e.g.
	// $seld_productName = array("val1", "val2");

	$GLOBALS["seld_productName"] = "";
	$GLOBALS["sel_productName"] =  $GLOBALS["seld_productName"];

	// Field clientName
	// Setup your default values for the extended filter below, e.g.
	// $seld_clientName = array("val1", "val2");

	$GLOBALS["seld_clientName"] = "";
	$GLOBALS["sel_clientName"] =  $GLOBALS["seld_clientName"];

	// Field projectName
	// Setup your default values for the extended filter below, e.g.
	// $seld_projectName = array("val1", "val2");

	$GLOBALS["seld_projectName"] = "";
	$GLOBALS["sel_projectName"] =  $GLOBALS["seld_projectName"];
}

// Check if filter applied
function CheckFilter() {

	// Check locationName popup filter
	if (!ewrpt_MatchedArray($GLOBALS["seld_locationName"], $GLOBALS["sel_locationName"]))
		return TRUE;

	// Check productName popup filter
	if (!ewrpt_MatchedArray($GLOBALS["seld_productName"], $GLOBALS["sel_productName"]))
		return TRUE;

	// Check clientName popup filter
	if (!ewrpt_MatchedArray($GLOBALS["seld_clientName"], $GLOBALS["sel_clientName"]))
		return TRUE;

	// Check projectName popup filter
	if (!ewrpt_MatchedArray($GLOBALS["seld_projectName"], $GLOBALS["sel_projectName"]))
		return TRUE;
	return FALSE;
}

// Show list of filters
function ShowFilterList() {

	// Initialize
	$sFilterList = "";

	// Field locationName
	$sExtWrk = "";
	$sWrk = "";
	if (is_array($GLOBALS["sel_locationName"]))
		$sWrk = ewrpt_JoinArray($GLOBALS["sel_locationName"], ", ", EW_REPORT_DATATYPE_STRING);
	if ($sExtWrk <> "" || $sWrk <> "")
		$sFilterList .= "Location <br />";
	if ($sExtWrk <> "")
		$sFilterList .= "&nbsp;&nbsp;$sExtWrk<br />";
	if ($sWrk <> "")
		$sFilterList .= "&nbsp;&nbsp;$sWrk<br />";

	// Field productName
	$sExtWrk = "";
	$sWrk = "";
	if (is_array($GLOBALS["sel_productName"]))
		$sWrk = ewrpt_JoinArray($GLOBALS["sel_productName"], ", ", EW_REPORT_DATATYPE_STRING);
	if ($sExtWrk <> "" || $sWrk <> "")
		$sFilterList .= "Product Name<br />";
	if ($sExtWrk <> "")
		$sFilterList .= "&nbsp;&nbsp;$sExtWrk<br />";
	if ($sWrk <> "")
		$sFilterList .= "&nbsp;&nbsp;$sWrk<br />";

	// Field clientName
	$sExtWrk = "";
	$sWrk = "";
	if (is_array($GLOBALS["sel_clientName"]))
		$sWrk = ewrpt_JoinArray($GLOBALS["sel_clientName"], ", ", EW_REPORT_DATATYPE_STRING);
	if ($sExtWrk <> "" || $sWrk <> "")
		$sFilterList .= "Client Name<br />";
	if ($sExtWrk <> "")
		$sFilterList .= "&nbsp;&nbsp;$sExtWrk<br />";
	if ($sWrk <> "")
		$sFilterList .= "&nbsp;&nbsp;$sWrk<br />";

	// Field projectName
	$sExtWrk = "";
	$sWrk = "";
	if (is_array($GLOBALS["sel_projectName"]))
		$sWrk = ewrpt_JoinArray($GLOBALS["sel_projectName"], ", ", EW_REPORT_DATATYPE_STRING);
	if ($sExtWrk <> "" || $sWrk <> "")
		$sFilterList .= "Project Name<br />";
	if ($sExtWrk <> "")
		$sFilterList .= "&nbsp;&nbsp;$sExtWrk<br />";
	if ($sWrk <> "")
		$sFilterList .= "&nbsp;&nbsp;$sWrk<br />";

	// Show Filters
	if ($sFilterList <> "")
		echo "CURRENT FILTERS:<br />$sFilterList";
}

/**
 * Regsiter your Custom filters here
 */

// Setup custom filters
function SetupCustomFilters() {

	// 1. Register your custom filter below (see example)
	// 2. Write your custom filter function (see example fucntions: GetLastMonthFilter, GetStartsWithAFilter)

}

/**
 * Write your Custom filters here
 */

// Filter for 'Last Month' (example)
function GetLastMonthFilter($FldExpression) {
	$today = getdate();
	$lastmonth = mktime(0, 0, 0, $today['mon']-1, 1, $today['year']);
	$sVal = date("Y|m", $lastmonth);
	$sWrk = $FldExpression . " BETWEEN " .
		ewrpt_QuotedValue(DateVal("month", $sVal, 1), EW_REPORT_DATATYPE_DATE) .
		" AND " .
		ewrpt_QuotedValue(DateVal("month", $sVal, 2), EW_REPORT_DATATYPE_DATE);
	return $sWrk;
}

// Filter for 'Starts With A' (example)
function GetStartsWithAFilter($FldExpression) {
	return $FldExpression . " LIKE 'A%'";
}
?>
