<?php
session_start();
ob_start();
?>
<?php
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // Always modified
header("Cache-Control: private, no-store, no-cache, must-revalidate"); // HTTP/1.1 
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache"); // HTTP/1.0
?>
<?php include "phprptinc/ewrcfg2.php"; ?>
<?php include "phprptinc/ewmysql.php"; ?>
<?php include "phprptinc/ewrfn2.php"; ?>
<?php include "phprptinc/ewrsecu2.php"; ?>
<?php

// Table level constants
define("EW_REPORT_TABLE_VAR", "TimeSheetAnalysisReport", TRUE);
define("EW_REPORT_TABLE_GROUP_PER_PAGE", "grpperpage", TRUE);
define("EW_REPORT_TABLE_SESSION_GROUP_PER_PAGE", "TimeSheetAnalysisReport_grpperpage", TRUE);
define("EW_REPORT_TABLE_START_GROUP", "start", TRUE);
define("EW_REPORT_TABLE_SESSION_START_GROUP", "TimeSheetAnalysisReport_start", TRUE);
define("EW_REPORT_TABLE_SESSION_SEARCH", "TimeSheetAnalysisReport_search", TRUE);
define("EW_REPORT_TABLE_CHILD_USER_ID", "childuserid", TRUE);
define("EW_REPORT_TABLE_SESSION_CHILD_USER_ID", "TimeSheetAnalysisReport_childuserid", TRUE);

// Table level SQL
define("EW_REPORT_TABLE_REPORT_SUMMARY_TYPE", "SUM", TRUE);
define("EW_REPORT_TABLE_REPORT_COLUMN_CAPTIONS", "", TRUE);
define("EW_REPORT_TABLE_REPORT_COLUMN_NAMES", "", TRUE);
$EW_REPORT_TABLE_SQL_TRANSFORM = "";
$EW_REPORT_TABLE_SQL_FROM = "tblclient INNER JOIN tblprojects ON (tblclient.clientID = tblprojects.clientID) INNER JOIN tblnccontracts ON (tblprojects.ncContractID = tblnccontracts.ncContractID) INNER JOIN tbltimesheet ON (tblclient.clientID = tbltimesheet.clientID) AND (tblprojects.projectID = tbltimesheet.projectID) INNER JOIN tblusers ON (tblusers.userID = tbltimesheet.userID) INNER JOIN tblproductgrp ON (tblusers.productGroupID = tblproductgrp.productID) INNER JOIN tbllocation ON (tblusers.locationID = tbllocation.locationID)";
$EW_REPORT_TABLE_SQL_SELECT = "SELECT tblusers.Uname AS `Uname`, tblclient.clientName AS `clientName`, tblprojects.projectName AS `projectName` <DistinctColumnFields> FROM " . $EW_REPORT_TABLE_SQL_FROM;
$EW_REPORT_TABLE_SQL_WHERE = "";
$EW_REPORT_TABLE_SQL_GROUPBY = "tblusers.Uname, tblclient.clientName, tblprojects.projectName";
$EW_REPORT_TABLE_SQL_HAVING = "";
$EW_REPORT_TABLE_SQL_ORDERBY = "tblusers.Uname ASC, tblclient.clientName ASC, tblprojects.projectName ASC";
$EW_REPORT_TABLE_SQL_PIVOT = "";
$EW_REPORT_TABLE_DISTINCT_SQL_SELECT = "SELECT DISTINCT tblproductgrp.productName FROM tblclient INNER JOIN tblprojects ON (tblclient.clientID = tblprojects.clientID) INNER JOIN tblnccontracts ON (tblprojects.ncContractID = tblnccontracts.ncContractID) INNER JOIN tbltimesheet ON (tblclient.clientID = tbltimesheet.clientID) AND (tblprojects.projectID = tbltimesheet.projectID) INNER JOIN tblusers ON (tblusers.userID = tbltimesheet.userID) INNER JOIN tblproductgrp ON (tblusers.productGroupID = tblproductgrp.productID) INNER JOIN tbllocation ON (tblusers.locationID = tbllocation.locationID)";
$EW_REPORT_TABLE_DISTINCT_SQL_WHERE = "";
$EW_REPORT_TABLE_DISTINCT_SQL_ORDERBY = "tblproductgrp.productName";
$EW_REPORT_TABLE_SQL_USERID_FILTER = "";
$af_Uname = NULL; // Popup filter for Uname
$af_projectName = NULL; // Popup filter for projectName
$af_clientName = NULL; // Popup filter for clientName
$af_productName = NULL; // Popup filter for productName
$af_locationName = NULL; // Popup filter for locationName
$af_hours = NULL; // Popup filter for hours
$af_leave = NULL; // Popup filter for leave
?>
<?php
$sExport = @$_GET["export"]; // Load export request
if ($sExport == "html") {

	// Printer friendly
}
if ($sExport == "excel") {
	header('Content-Type: application/vnd.ms-excel');
	header('Content-Disposition: attachment; filename=' . EW_REPORT_TABLE_VAR .'.xls');
}
if ($sExport == "word") {
	header('Content-Type: application/vnd.ms-word');
	header('Content-Disposition: attachment; filename=' . EW_REPORT_TABLE_VAR .'.doc');
}
?>
<?php

// Initialize common variables
// Paging variables

$nRecCount = 0; // Record count
$nStartGrp = 0; // Start group
$nStopGrp = 0; // Stop group
$nTotalGrps = 0; // Total groups
$nGrpCount = 0; // Group count
$nDisplayGrps = 3; // Groups per page
$nGrpRange = 10;

// Clear field for ext filter
$sClearExtFilter = "";

// Dropdown filters
// Extended filters
// Custom filters

$ewrpt_CustomFilters = array();
?>
<?php

// Static group variables
$x_Uname = NULL;
$o_Uname = NULL;
$t_Uname = NULL;
$g_Uname = NULL;
$ft_Uname = 200;
$rf_Uname = NULL;
$rt_Uname = NULL;
$x_clientName = NULL;
$o_clientName = NULL;
$t_clientName = NULL;
$g_clientName = NULL;
$ft_clientName = 200;
$rf_clientName = NULL;
$rt_clientName = NULL;
$x_projectName = NULL;
$o_projectName = NULL;
$t_projectName = NULL;
$g_projectName = NULL;
$ft_projectName = 200;
$rf_projectName = NULL;
$rt_projectName = NULL;

// Column variables
$x_productName = NULL;
$ft_productName = 200;
$rf_productName = NULL;
$rt_productName = NULL;

// Summary variables
$x_hours = NULL;
?>
<?php

// Open connection to the database
$conn = ewrpt_Connect();

// Filter
$sFilter = "";
$sButtonImage = "";
$sDivDisplay = FALSE;
$sSort = "";

// Set up groups per page dynamically
SetUpDisplayGrps();

// Popup values and selections
// Set up popup filter

SetupPopup();

// Load columns to array
GetColumns();

// Extended filter
$sExtendedFilter = "";

// No extended filter
$sExtendedFilter = $sFilter;

// No filter
$bFilterApplied = FALSE;

// Build SQL
$sSql = ewrpt_BuildReportSql($EW_REPORT_TABLE_SQL_TRANSFORM, $EW_REPORT_TABLE_SQL_SELECT, $EW_REPORT_TABLE_SQL_WHERE, $EW_REPORT_TABLE_SQL_GROUPBY, "", $EW_REPORT_TABLE_SQL_ORDERBY, $EW_REPORT_TABLE_SQL_PIVOT, $sExtendedFilter, @$sSort);

// Load recordset
$rs = $conn->Execute($sSql);
$rscnt = ($rs) ? $rs->RecordCount() : 0;

// Init report data
InitReportData($rs);
if ($nDisplayGrps <= 0) // Display all groups
	$nDisplayGrps = $nTotalGrps;
$nStartGrp = 1;

// Set up start position if not export all
if (!(EW_REPORT_EXPORT_ALL && @$sExport <> ""))
	SetUpStartGroup();
?>
<?php include "phprptinc/header.php"; ?>
<?php if (@$sExport == "") { ?>
<?php } ?>
<?php if (@$sExport == "") { ?>
<script src="phprptjs/x/x_core.js" type="text/javascript"></script>
<script src="phprptjs/x/x_event.js" type="text/javascript"></script>
<script src="phprptjs/x/x_drag.js" type="text/javascript"></script>
<script src="phprptjs/popup.js" type="text/javascript"></script>
<script src="phprptjs/ewrptpop.js" type="text/javascript"></script>
<script src="FusionChartsFree/JSClass/FusionCharts.js" type="text/javascript"></script>
<script type="text/javascript">
var EW_REPORT_POPUP_ALL = "(All)";
var EW_REPORT_POPUP_OK = "  OK  ";
var EW_REPORT_POPUP_CANCEL = "Cancel";
var EW_REPORT_POPUP_FROM = "From";
var EW_REPORT_POPUP_TO = "To";
var EW_REPORT_POPUP_PLEASE_SELECT = "Please Select";
var EW_REPORT_POPUP_NO_VALUE = "No value selected!";

// popup fields
</script>
<!-- Table container (begin) -->
<table id="ewContainer" cellspacing="0" cellpadding="0" border="0">
<!-- Top container (begin) -->
<tr><td colspan="3" class="ewPadding"><div id="ewTop" class="phpreportmaker">
<!-- top slot -->
<a name="top"></a>
<?php } ?>
Time Sheet Analysis Report
<?php if (@$sExport == "") { ?>
&nbsp;&nbsp;<a href="TimeSheetAnalysisReportctb.php?export=html">Printer Friendly</a>
&nbsp;&nbsp;<a href="TimeSheetAnalysisReportctb.php?export=excel">Export to Excel</a>
&nbsp;&nbsp;<a href="TimeSheetAnalysisReportctb.php?export=word">Export to Word</a>
<?php } ?>
<br /><br />
<?php if (@$sExport == "") { ?>
</div></td></tr>
<!-- Top container (end) -->
<tr>
	<!-- Left container (begin) -->
	<td valign="top"><div id="ewLeft" class="phpreportmaker">
	<!-- left slot -->
	</div></td>
	<!-- Left container (end) -->
	<!-- Center container (report) (begin) -->
	<td valign="top" class="ewPadding"><div id="ewCenter" class="phpreportmaker">
	<!-- center slot -->
<?php } ?>
<!-- crosstab report starts -->
<div id="report_crosstab">
<!-- Report grid (begin) -->
<table id="ewReport" class="ewTable">
	<!-- Table header -->
	<tr class="ewTableRow">
		<td colspan="3" nowrap><div class="phpreportmaker">hours (SUM)&nbsp;</div></td>
		<td class="ewRptColHeader" colspan="<?php echo @$ncolspan; ?>" nowrap>
			product Name
		</td>
	</tr>
	<tr>
		<td class="ewRptGrpHeader1">
			Uname
		</td>
		<td class="ewRptGrpHeader2">
			client Name
		</td>
		<td class="ewRptGrpHeader3">
			project Name
		</td>
<!-- Dynamic columns begin -->
	<?php
	for ($iy = 1; $iy < count($val); $iy++) {
		if ($col[$iy][2]) {
			$x_productName = $col[$iy][1];
	?>
		<td class="ewTableHeader" valign="top">
<?php echo $x_productName ?>
</td>
	<?php
		}
	}
	?>
<!-- Dynamic columns end -->
		<?php $x_productName = "Total"; ?>
		<td class="ewTableHeader" valign="top">
<?php echo $x_productName ?>
</td>
	</tr>
<?php
if ($nTotalGrps > 0) {

// Set the last group to display if not export all
if (EW_REPORT_EXPORT_ALL && @$sExport <> "") {
	$nStopGrp = $nTotalGrps;
} else {
	$nStopGrp = $nStartGrp + $nDisplayGrps - 1;
}

// Stop group <= total number of groups
if (intval($nStopGrp) > intval($nTotalGrps)) {
	$nStopGrp = $nTotalGrps;
}

// Navigate
$grpvalue = "";
$nRecCount = 0;

// Get first row
if ($rscnt > 0) {
	GetRow(1);
	$nGrpCount = 1;
}
while ($rs && !$rs->EOF) {

	// Process groups
	if (intval($nGrpCount) >= intval($nStartGrp) && $nGrpCount <= $nStopGrp) {
		$nRecCount++;

		// Set row color
		$sItemRowClass = " class=\"ewTableRow\"";

		// Display alternate color for rows
		if ($nRecCount % 2 <> 1)
			$sItemRowClass = " class=\"ewTableAltRow\"";

		// Show group values
		$g_Uname = $x_Uname;
		if ($x_Uname <> "" && $o_Uname == $x_Uname && !ChkLvlBreak(1)) {
			$g_Uname = "";
		} elseif (is_null($x_Uname)) {
			$g_Uname = EW_REPORT_NULL_LABEL;
		} elseif ($x_Uname == "") {
			$g_Uname = EW_REPORT_EMPTY_LABEL;
		}
		$g_clientName = $x_clientName;
		if ($x_clientName <> "" && $o_clientName == $x_clientName && !ChkLvlBreak(2)) {
			$g_clientName = "";
		} elseif (is_null($x_clientName)) {
			$g_clientName = EW_REPORT_NULL_LABEL;
		} elseif ($x_clientName == "") {
			$g_clientName = EW_REPORT_EMPTY_LABEL;
		}
		$g_projectName = $x_projectName;
		if ($x_projectName <> "" && $o_projectName == $x_projectName && !ChkLvlBreak(3)) {
			$g_projectName = "";
		} elseif (is_null($x_projectName)) {
			$g_projectName = EW_REPORT_NULL_LABEL;
		} elseif ($x_projectName == "") {
			$g_projectName = EW_REPORT_EMPTY_LABEL;
		}
?>
	<!-- Data -->
	<tr<?php echo $sItemRowClass; ?>>
		<!-- Uname -->
		<td class="ewRptGrpField1"><?php $t_Uname = $x_Uname; $x_Uname = $g_Uname; ?>
<?php echo $x_Uname ?>
<?php $x_Uname = $t_Uname; ?></td>
		<!-- client Name -->
		<td class="ewRptGrpField2"><?php $t_clientName = $x_clientName; $x_clientName = $g_clientName; ?>
<?php echo $x_clientName ?>
<?php $x_clientName = $t_clientName; ?></td>
		<!-- project Name -->
		<td class="ewRptGrpField3"><?php $t_projectName = $x_projectName; $x_projectName = $g_projectName; ?>
<?php echo $x_projectName ?>
<?php $x_projectName = $t_projectName; ?></td>
<!-- Dynamic columns begin -->
	<?php
	$rowsmry = 0;
	for ($iy = 1; $iy < count($val); $iy++) {
		if ($col[$iy][2]) {
			$rowval = $val[$iy];
			$rowsmry = ewrpt_SummaryValue($rowsmry, $rowval, EW_REPORT_TABLE_REPORT_SUMMARY_TYPE);
			$x_hours = $val[$iy];
	?>
		<!-- <?php echo $col[$iy][1]; ?> -->
		<td>
<?php echo $x_hours ?>
</td>
	<?php
		}
	}
	?>
<!-- Dynamic columns end -->
	<?php $x_hours = $rowsmry; ?>
		<td>
<?php echo $x_hours ?>
</td>
	</tr>
<?php

		// Accumulate page summary
		AccumulateSummary();
	}

	// Accumulate grand summary
	AccumulateGrandSummary();

	// Save old group values
	$o_Uname = $x_Uname;
	$o_clientName = $x_clientName;
	$o_projectName = $x_projectName;

	// Get next record
	GetRow(2);
	if (intval($nGrpCount) >= intval($nStartGrp) && $nGrpCount <= $nStopGrp) {
?>
<?php

		// Process summary level 3
		if (ChkLvlBreak(3)) {
?>
	<!-- Summary project Name (level 3) -->
	<tr>
		<td class="ewRptGrpField1"></td>
		<td class="ewRptGrpField2"></td>
		<?php $t_projectName = $x_projectName; $x_projectName = $o_projectName; ?>
		<td class="ewRptGrpSummary3" colspan="1">Summary for project Name: 
<?php echo $x_projectName ?>
</td>
		<?php $x_projectName = $t_projectName; ?>
<!-- Dynamic columns begin -->
	<?php
	$rowsmry = 0;
	for ($iy = 1; $iy <= $ncol; $iy++) {
		if ($col[$iy][2]) {
			$rowval = $smry[$iy][3];
			$rowsmry = ewrpt_SummaryValue($rowsmry, $rowval, EW_REPORT_TABLE_REPORT_SUMMARY_TYPE);
			$x_hours = $smry[$iy][3];
	?>
		<!-- <?php echo $col[$iy][1]; ?> -->
		<td class="ewRptGrpSummary3">
<?php echo $x_hours ?>
</td>
	<?php
		}
	}
	?>
<!-- Dynamic columns end -->
	<?php $x_hours = $rowsmry; ?>
		<td class="ewRptGrpSummary3">
<?php echo $x_hours ?>
</td>
	</tr>
<?php

			// Reset level 3 summary
			ResetLevelSummary(3);
		}
?>
<?php
	}

	// Increment group count
	if (ChkLvlBreak(1))
		$nGrpCount++;
}
?>
	<!-- Page Summary -->
	<tr class="ewRptPageSummary">
	<td colspan="3">Page Total</td>
<!-- Dynamic columns begin -->
	<?php
	$rowsmry = 0;
	for ($iy = 1; $iy <= $ncol; $iy++) {
		if ($col[$iy][2]) {
			$rowval = $smry[$iy][0];
			$rowsmry = ewrpt_SummaryValue($rowsmry, $rowval, EW_REPORT_TABLE_REPORT_SUMMARY_TYPE);
			$x_hours = $smry[$iy][0];
	?>
		<!-- <?php echo $col[$iy][1]; ?> -->
		<td>
<?php echo $x_hours ?>
</td>
	<?php
		}
	}
	?>
<!-- Dynamic columns end -->
	<?php $x_hours = $rowsmry; ?>
		<td>
<?php echo $x_hours ?>
</td>
	</tr>
	<!-- Grand Total -->
	<tr class="ewRptGrandSummary">
	<td colspan="3">Grand Total</td>
<!-- Dynamic columns begin -->
	<?php 
	$rowsmry = 0;
	for ($iy = 1; $iy <= $ncol; $iy++) {
		if ($col[$iy][2]) {
			$rowval = $grandsmry[$iy];
			$rowsmry = ewrpt_SummaryValue($rowsmry, $rowval, EW_REPORT_TABLE_REPORT_SUMMARY_TYPE);
			$x_hours = $grandsmry[$iy];
	?>
		<!-- <?php echo $col[$iy][1]; ?> -->
		<td>
<?php echo $x_hours ?>
</td>
	<?php
		}
	}
	?>
<!-- Dynamic columns end -->
	<?php $x_hours = $rowsmry; ?>
		<td>
<?php echo $x_hours ?>
</td>
	</tr>
<?php } ?>
</table>
<br />
<?php if (@$sExport == "") { ?>
<form action="TimeSheetAnalysisReportctb.php" name="ewpagerform" id="ewpagerform">
<table border="0" cellspacing="0" cellpadding="0">
	<tr>
		<td nowrap>
<?php
if ($nTotalGrps > 0) {
	$rsEof = ($nTotalGrps < ($nStartGrp + $nDisplayGrps));
	$PrevStart = $nStartGrp - $nDisplayGrps;
	if ($PrevStart < 1)
		$PrevStart = 1;
	$NextStart = $nStartGrp + $nDisplayGrps;
	if ($NextStart > $nTotalGrps)
		$NextStart = $nStartGrp;
	$LastStart = intval(($nTotalGrps-1)/$nDisplayGrps)*$nDisplayGrps+1;
?>
	<table border="0" cellspacing="0" cellpadding="0"><tr><td><span class="phpreportmaker">Page&nbsp;</span></td>
<!--first page button-->
	<?php if ($nStartGrp == 1) { ?>
	<td><img src="phprptimages/firstdisab.gif" alt="First" width="16" height="16" border="0"></td>
	<?php } else { ?>
	<td><a href="TimeSheetAnalysisReportctb.php?start=1"><img src="phprptimages/first.gif" alt="First" width="16" height="16" border="0"></a></td>
	<?php } ?>
<!--previous page button-->
	<?php if ($PrevStart == $nStartGrp) { ?>
	<td><img src="phprptimages/prevdisab.gif" alt="Previous" width="16" height="16" border="0"></td>
	<?php } else { ?>
	<td><a href="TimeSheetAnalysisReportctb.php?start=<?php echo $PrevStart; ?>"><img src="phprptimages/prev.gif" alt="Previous" width="16" height="16" border="0"></a></td>
	<?php } ?>
<!--current page number-->
	<td><input type="text" name="pageno" value="<?php echo intval(($nStartGrp-1)/$nDisplayGrps+1); ?>" size="4"></td>
<!--next page button-->
	<?php if ($NextStart == $nStartGrp) { ?>
	<td><img src="phprptimages/nextdisab.gif" alt="Next" width="16" height="16" border="0"></td>
	<?php } else { ?>
	<td><a href="TimeSheetAnalysisReportctb.php?start=<?php echo $NextStart; ?>"><img src="phprptimages/next.gif" alt="Next" width="16" height="16" border="0"></a></td>
	<?php  } ?>
<!--last page button-->
	<?php if ($LastStart == $nStartGrp) { ?>
	<td><img src="phprptimages/lastdisab.gif" alt="Last" width="16" height="16" border="0"></td>
	<?php } else { ?>
	<td><a href="TimeSheetAnalysisReportctb.php?start=<?php echo $LastStart; ?>"><img src="phprptimages/last.gif" alt="Last" width="16" height="16" border="0"></a></td>
	<?php } ?>
	<td><span class="phpreportmaker">&nbsp;of <?php echo intval(($nTotalGrps-1)/$nDisplayGrps+1);?></span></td>
	</tr></table>
	<?php
	if ($nStartGrp > $nTotalGrps)
		$nStartGrp = $nTotalGrps;
	$nStopGrp = $nStartGrp + $nDisplayGrps - 1;
	$nGrpCount = $nTotalGrps - 1;
	if ($rsEof)
		$nGrpCount = $nTotalGrps;
	if ($nStopGrp > $nGrpCount)
		$nStopGrp = $nGrpCount; ?>
	<span class="phpreportmaker"> <?php echo $nStartGrp; ?> to <?php echo $nStopGrp; ?> of <?php echo $nTotalGrps; ?></span>
<?php } else { ?>
	<?php if ($sExtendedFilter == "0=101") { ?>
	<span class="phpreportmaker">Please enter search criteria</span>
	<?php } else { ?>
	<span class="phpreportmaker">No records found</span>
	<?php } ?>
<?php } ?>
		</td>
<?php if ($nTotalGrps > 0) { ?>
		<td nowrap>&nbsp;&nbsp;&nbsp;&nbsp;</td>
		<td align="right" valign="top" nowrap><span class="phpreportmaker">Groups Per Page&nbsp;
<select name="<?php echo EW_REPORT_TABLE_GROUP_PER_PAGE; ?>" onChange="this.form.submit();" class="phpreportmaker">
<option value="1"<?php if ($nDisplayGrps == 1) echo " selected" ?>>1</option>
<option value="2"<?php if ($nDisplayGrps == 2) echo " selected" ?>>2</option>
<option value="3"<?php if ($nDisplayGrps == 3) echo " selected" ?>>3</option>
<option value="4"<?php if ($nDisplayGrps == 4) echo " selected" ?>>4</option>
<option value="5"<?php if ($nDisplayGrps == 5) echo " selected" ?>>5</option>
<option value="10"<?php if ($nDisplayGrps == 10) echo " selected" ?>>10</option>
<option value="20"<?php if ($nDisplayGrps == 20) echo " selected" ?>>20</option>
<option value="50"<?php if ($nDisplayGrps == 50) echo " selected" ?>>50</option>
<option value="ALL"<?php if (@$_SESSION[EW_REPORT_TABLE_SESSION_GROUP_PER_PAGE] == -1) echo " selected" ?>>All Records</option>
</select>
		</span></td>
<?php } ?>
	</tr>
</table>
</form>
<?php } ?>
</div>
<!-- Crosstab report ends -->
<?php if (@$sExport == "") { ?>
	</div><br /></td>
	<!-- Center container (report) (end) -->
	<!-- Right container (begin) -->
	<td valign="top"><div id="ewRight" class="phpreportmaker">
	<!-- right slot -->
	</div></td>
	<!-- Right container (end) -->
</tr>
<!-- Bottom container (begin) -->
<tr><td colspan="3"><div id="ewBottom" class="phpreportmaker">
	<!-- bottom slot -->
	</div><br /></td></tr>
<!-- Bottom container (end) -->
</table>
<!-- Table container (end) -->
<?php } ?>
<?php

// Close recordset and connection
if ($rs)
	$rs->Close();
$conn->Close();
?>
<?php include "phprptinc/footer.php"; ?>
<?php

// Get column values
function GetColumns() {
	global $conn;
	global $EW_REPORT_TABLE_SQL_SELECT;
	global $EW_REPORT_TABLE_DISTINCT_SQL_SELECT;
	global $EW_REPORT_TABLE_DISTINCT_SQL_WHERE;
	global $EW_REPORT_TABLE_DISTINCT_SQL_ORDERBY;
	global $sFilter, $sSort;
	global $ncol, $col, $val, $oval, $cnt, $smry, $grandsmry, $ncolspan;
	global $sel_productName;

	// Build SQL
	$sSql = ewrpt_BuildReportSql("", $EW_REPORT_TABLE_DISTINCT_SQL_SELECT, $EW_REPORT_TABLE_DISTINCT_SQL_WHERE, "", "", $EW_REPORT_TABLE_DISTINCT_SQL_ORDERBY, "", $sFilter, @$sSort);

	// Load recordset
	$rscol = $conn->Execute($sSql);

	// Get distinct column count
	$ncol = ($rscol) ? $rscol->RecordCount() : 0;
	if ($ncol == 0) {
		$rscol->Close();
		echo "No distinct column values for sql: " . $sSql . "<br />";
		exit();
	}

	// 1st dimension = no of groups (level 0 used for grand total)
	// 2nd dimension = no of distinct values

	$nGrps = 3;
	$col = ewrpt_Init2DArray($ncol+1, 2, NULL);
	$val = ewrpt_InitArray($ncol+1, NULL);
	$oval = ewrpt_InitArray($ncol+1, NULL);
	$cnt = ewrpt_Init2DArray($ncol+1, $nGrps+1, NULL);
	$smry = ewrpt_Init2DArray($ncol+1, $nGrps+1, NULL);
	$grandsmry = ewrpt_InitArray($ncol+1, NULL);

	// Reset summary values
	ResetLevelSummary(0);
	$colcnt = 0;
	while (!$rscol->EOF) {
		if (is_null($rscol->fields[0])) {
			$wrkValue = "";
			$wrkCaption = EW_REPORT_NULL_LABEL;
		} elseif ($rscol->fields[0] == "") {
			$wrkValue = "";
			$wrkCaption = EW_REPORT_EMPTY_LABEL;
		} else {
			$wrkValue = $rscol->fields[0];
			$wrkCaption = $rscol->fields[0];
		}
		$colcnt++;
		$col[$colcnt][0] = $wrkValue; // value
		$col[$colcnt][1] = $wrkCaption; // caption
		$col[$colcnt][2] = TRUE; // column visible
		$rscol->MoveNext();
	}
	$rscol->Close();

	// Rebuild SQL
	$sSqlFlds = "";
	for ($colcnt = 1; $colcnt <= $ncol; $colcnt++) {
		$sFld = ewrpt_CrossTabField("SUM", "`hours`", "tblproductgrp.productName", "", $col[$colcnt][0], "'", $colcnt);
		$sSqlFlds .= ", " . $sFld;
	}
	$EW_REPORT_TABLE_SQL_SELECT = str_replace("<DistinctColumnFields>", $sSqlFlds, $EW_REPORT_TABLE_SQL_SELECT);

	// Get active columns
	if (!is_array($sel_productName)) {
		$ncolspan = $ncol;
	} else {
		$ncolspan = 0;
		for ($i = 0; $i < count($col); $i++) {
			$bSelected = FALSE;
			for ($j = 0; $j < count($sel_productName); $j++) {
				if (trim($sel_productName[$j]) == trim($col[$i][0])) {
					$ncolspan++;
					$bSelected = TRUE;
					break;
				}
			}
			$col[$i][2] = $bSelected;
		}
	}
	$ncolspan++; // Add summary column
}

// Get row values
function GetRow($opt) {
	global $rs, $val;
	if (!$rs)
		return;
	if ($opt == 1) { // Get first row
		$rs->MoveFirst();
	} else { // Get next row
		$rs->MoveNext();
	}
	while (!$rs->EOF) {
		if (ValidRow($rs)) {
			$GLOBALS['x_Uname'] = $rs->fields('Uname');
			$GLOBALS['x_clientName'] = $rs->fields('clientName');
			$GLOBALS['x_projectName'] = $rs->fields('projectName');
			for ($ix = 1; $ix < count($val); $ix++)
				$val[$ix] = $rs->fields[$ix+3-1];
			break;
		} else {
			$rs->MoveNext();
		}
	}
	if ($rs->EOF) {
		$GLOBALS['x_Uname'] = "";
		$GLOBALS['x_clientName'] = "";
		$GLOBALS['x_projectName'] = "";
	}
}

// Check level break
function ChkLvlBreak($lvl) {
	switch ($lvl) {
		case 1:
			return (is_null($GLOBALS["x_Uname"]) && !is_null($GLOBALS["o_Uname"])) ||
			(!is_null($GLOBALS["x_Uname"]) && is_null($GLOBALS["o_Uname"])) ||
			($GLOBALS["x_Uname"] <> $GLOBALS["o_Uname"]);
		case 2:
			return (is_null($GLOBALS["x_clientName"]) && !is_null($GLOBALS["o_clientName"])) ||
			(!is_null($GLOBALS["x_clientName"]) && is_null($GLOBALS["o_clientName"])) ||
			($GLOBALS["x_clientName"] <> $GLOBALS["o_clientName"]) || ChkLvlBreak(1); // Recurse upper level
		case 3:
			return (is_null($GLOBALS["x_projectName"]) && !is_null($GLOBALS["o_projectName"])) ||
			(!is_null($GLOBALS["x_projectName"]) && is_null($GLOBALS["o_projectName"])) ||
			($GLOBALS["x_projectName"] <> $GLOBALS["o_projectName"]) || ChkLvlBreak(2); // Recurse upper level
	}
}

// Accummulate summary
function AccumulateSummary() {
	global $val, $cnt, $smry;
	for ($ix = 1; $ix < count($smry); $ix++) {
		for ($iy = 0; $iy < count($smry[$ix]); $iy++) {
			$valwrk = $val[$ix];
			$cnt[$ix][$iy]++;
			$smry[$ix][$iy] = ewrpt_SummaryValue($smry[$ix][$iy], $valwrk, EW_REPORT_TABLE_REPORT_SUMMARY_TYPE);
		}
	}
}

// Reset level summary
function ResetLevelSummary($lvl) {

	// Clear summary values
	global $nRecCount, $cnt, $smry, $grandsmry;
	for ($ix = 1; $ix < count($smry); $ix++) {
		for ($iy = $lvl; $iy < count($smry[$ix]); $iy++) {
			$cnt[$ix][$iy] = 0;
			$smry[$ix][$iy] = 0;
		}
	}

	// Clear grand summary
	if ($lvl == 0) {
		for ($iy = 1; $iy < count($grandsmry); $iy++)
			$grandsmry[$iy] = 0;
	}

	// Reset record count
	$nRecCount = 0;
}

// Accummulate grand summary
function AccumulateGrandSummary() {
	global $val, $grandsmry;
	for ($iy = 1; $iy < count($grandsmry); $iy++) {
		$valwrk = $val[$iy];
		$grandsmry[$iy] = ewrpt_SummaryValue($grandsmry[$iy], $valwrk, EW_REPORT_TABLE_REPORT_SUMMARY_TYPE);
	}
}

// Set up starting group
function SetUpStartGroup() {
	global $nStartGrp, $nTotalGrps, $nDisplayGrps;

	// Exit if no groups
	if ($nDisplayGrps == 0)
		return;

	// Check for a 'start' parameter
	if (@$_GET[EW_REPORT_TABLE_START_GROUP] != "") {
		$nStartGrp = $_GET[EW_REPORT_TABLE_START_GROUP];
		$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP] = $nStartGrp;
	} elseif (@$_GET["pageno"] != "") {
		$nPageNo = $_GET["pageno"];
		if (is_numeric($nPageNo)) {
			$nStartGrp = ($nPageNo-1)*$nDisplayGrps+1;
			if ($nStartGrp <= 0) {
				$nStartGrp = 1;
			} elseif ($nStartGrp >= intval(($nTotalGrps-1)/$nDisplayGrps)*$nDisplayGrps+1) {
				$nStartGrp = intval(($nTotalGrps-1)/$nDisplayGrps)*$nDisplayGrps+1;
			}
			$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP] = $nStartGrp;
		} else {
			$nStartGrp = @$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP];	
		}
	} else {
		$nStartGrp = @$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP];
	}

	// Check if correct start group counter
	if (!is_numeric($nStartGrp) || $nStartGrp == "") { // Avoid invalid start group counter
		$nStartGrp = 1; // Reset start group counter
		$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP] = $nStartGrp;
	} elseif (intval($nStartGrp) > intval($nTotalGrps)) { // Avoid starting group > total groups
		$nStartGrp = intval(($nTotalGrps-1)/$nDisplayGrps) * $nDisplayGrps + 1; // Point to last page first group
		$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP] = $nStartGrp;
	} elseif (($nStartGrp-1) % $nDisplayGrps <> 0) {
		$nStartGrp = intval(($nStartGrp-1)/$nDisplayGrps) * $nDisplayGrps + 1; // Point to page boundary
		$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP] = $nStartGrp;
	}
}

// Set up popup
function SetupPopup() {
	global $conn, $sFilter;

	// Process post back form
	if (count($_POST) > 0) {
		$sName = @$_POST["popup"]; // Get popup form name
		if ($sName <> "") {
			$cntValues = (is_array(@$_POST["sel_$sName"])) ? count($_POST["sel_$sName"]) : 0;
			if ($cntValues > 0) {
				$arValues = ewrpt_StripSlashes($_POST["sel_$sName"]);
				if (trim($arValues[0]) == "") // Select all
					$arValues = EW_REPORT_INIT_VALUE;
				$_SESSION["sel_$sName"] = $arValues;
				$_SESSION["rf_$sName"] = ewrpt_StripSlashes(@$_POST["rf_$sName"]);
				$_SESSION["rt_$sName"] = ewrpt_StripSlashes(@$_POST["rt_$sName"]);
				ResetPager();
			}
		}

	// Get 'reset' command
	} elseif (@$_GET["cmd"] <> "") {
		$sCmd = $_GET["cmd"];
		if (strtolower($sCmd) == "reset") {
			ResetPager();
		}
	}

	// Load selection criteria to array
}

// Reset pager
function ResetPager() {
	global $nStartGrp;

	// Reset start position (reset command)
	$nStartGrp = 1;
	$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP] = $nStartGrp;
}

// Initialize group data - total number of groups + grouping field arrays
function InitReportData(&$rs) {
	global $conn, $nTotalGrps, $bFilterApplied, $sFilter;

	// Initialize group count
	$grpcnt = 0;
	while ($rs && !$rs->EOF) {
		$bValidRow = ValidRow($rs);
		if ($bValidRow) {
			$bNewGroup = ($grpcnt == 0) ||
				(is_null($grpvalue) && !is_null($rs->fields[0])) ||
				(!is_null($grpvalue) && is_null($rs->fields[0])) ||
				($grpvalue <> $rs->fields[0]);
			if ($bNewGroup) {
				$grpvalue = $rs->fields[0];
				$grpcnt++;
			}
		}
		$rs->MoveNext();
	}

	// Set up total number of groups
	$nTotalGrps = $grpcnt;
}

// Check if row is valid
function ValidRow(&$rs) {
	if (!HasColumnValues($rs)) // Rows with values
		return FALSE;
	return TRUE;
}

// Check if any column values is present
function HasColumnValues(&$rs) {
	global $col;
	for ($i = 1; $i < count($col); $i++) {
		if ($col[$i][2]) {
			if ($rs->fields[3+$i-1] <> 0) return TRUE;
		}
	}
	return FALSE;
}
?>
<?php

// Set up number of groups displayed per page
function SetUpDisplayGrps() {
	global $nDisplayGrps, $nStartGrp;
	$sWrk = @$_GET[EW_REPORT_TABLE_GROUP_PER_PAGE];
	if ($sWrk <> "") {
		if (is_numeric($sWrk)) {
			$nDisplayGrps = intval($sWrk);
		} else {
			if (strtoupper($sWrk) == "ALL") { // display all groups
				$nDisplayGrps = -1;
			} else {
				$nDisplayGrps = 3; // Non-numeric, load default
			}
		}
		$_SESSION[EW_REPORT_TABLE_SESSION_GROUP_PER_PAGE] = $nDisplayGrps; // Save to session

		// Reset start position (reset command)
		$nStartGrp = 1;
		$_SESSION[EW_REPORT_TABLE_SESSION_START_GROUP] = $nStartGrp;
	} else {
		if (@$_SESSION[EW_REPORT_TABLE_SESSION_GROUP_PER_PAGE] <> "") {
			$nDisplayGrps = $_SESSION[EW_REPORT_TABLE_SESSION_GROUP_PER_PAGE]; // Restore from session
		} else {
			$nDisplayGrps = 3; // Load default
		}
	}
}
?>
