<?php
/**
 * class:         sendmail.class.php
 * description:    class for sending HTML mails with attachments
 * created:        21.02.2003
 * last change:    26.01.2004
 * author:        Gnther Bauer <guenni1981@lycos.de>
 * modifications dcembre 2003: Alain BOURDEAU <alain.bourdeau@wanadoo.fr>
 * Pour l'utilisation sur la plateforme de la cooprative http://www.ouvaton.org. Les \r ont t limins et la blise MIME---- a t mise en tte du Header
 * copyright:    Gnther Bauer
 */
	class sendmail
	{
		// Variable deklarieren = declaration des variables
		var $emailheader = "";
        var $createur = "";  // ajout du 5em argument de l'e-mail
		var $textheader = "";
		var $textboundary = "";
		var $emailboundary = "";
		var $charset = "";
		var $betreff = "";
		//var $empfaenger = array();  // transformation en array
		var $attachment = array();
		var $to = array();
		var $cc = array();
		var $bcc = array();

		// Konstruktor = construction des parametres fonctionnels
		function sendmail()
		{
			$this->textboundary = uniqid(time());
			$this->emailboundary = uniqid(time());
			$this->charset = "ISO-8859-1";
		}

		// Funktion zum setzen des CharSets = la fonction de traduction des caractres
		function SetCharSet($char)
		{
			$this->charset = $char;
		}

		// Von wem die Email kommt in den Header setzen = initialisation de l'meteur
		function from($name,$email)
		{
			$this->emailheader .= "From: ".$name."<".$email.">\n";
                        $this->createur = "-F $email";
		}

		// Funktion um den Adressaten anzugeben = la prise en compte des destinataires individuels (tranform en tableau-array)
		function to($kopie_an_empfaenger)
		{
			$this->to[] = $kopie_an_empfaenger;
			
		}

		// Funktion zum senden einer Kopie an Cc Empfnger = la prise en compte des destinataires Cc
		function cc($kopie_an_empfaenger)
		{
			$this->cc[] = $kopie_an_empfaenger;
		}

		// Funktion zum senden einer Kopie an Bcc Empfnger = la prise en compte des destinataires Bcc
		function bcc($kopie_an_empfaenger)
		{
			$this->bcc[] = $kopie_an_empfaenger;
		}

		// Erstellt den Header der Mime-Mail = intgration des destinataires Cc et-ou Bcc dans le Header Mime-Mail
		function makeMimeMail()
		{
			if(count($this->cc) > 0)
			{
				$this->emailheader .= "Cc: ";
				for($i=0;$i<count($this->cc);$i++)
				{
					if($i > 0) $this->emailheader .= ",";
					$this->emailheader .= $this->cc[$i];
				}
				$this->emailheader .= "\n";
			}
			if(count($this->to) > 0)
			{
				$this->emailheader .= "to: ";
				for($i=0;$i<count($this->to);$i++)
				{
					if($i > 0) $this->emailheader .= ",";
					$this->emailheader .= $this->to[$i];
				}
				$this->emailheader .= "\n";
			}
			if(count($this->bcc) > 0)
			{
				$this->emailheader .= "Bcc: ";
				for($j=0;$j<count($this->bcc);$j++)
				{
					if($j > 0) $this->emailheader .= ",";
					$this->emailheader .= $this->bcc[$j];
				}
				$this->emailheader .= "\n";
			}
                        // la balise MIME-Version: 1.0\nContent-Type: multipart/mixed; boundary a t mise dans le emailheader
			$this->emailheader .= "MIME-Version: 1.0\nContent-Type: multipart/mixed;\n\tboundary=\"".$this->emailboundary."\"\r\n";
		}

		// Funktion fr den Betreff anzugeben = prise en compte de l'objet du message
		function subject($subject)
		{
			$this->betreff = $subject;
		}

		// Textdaten in Email Header packen = intgration du texte du message dans le Header et crtion du double en html
		function text($text)
		{
			
			$this->textheader .= strip_tags($text)."\n";
			
		}

		// Funktion zum anhngen fr Attachments in der Email = prise en compte des fichiers attachs-joints au message
		function attachment($datei)
		{
			// berprfen ob File Existiert = vrification de l'existence du fichier
			if(is_file($datei))
			{
				// Header fr Attachment erzeugen = cration de l'entte de l'attachement
				$attachment_header = "--".$this->emailboundary."\n" ;
				$attachment_header .= "Content-Type: application/octet-stream;\n name=\"".$this->GetFileName($datei)."\"\n";
				$attachment_header .= "Content-Transfer-Encoding: base64\n";
				$attachment_header .= "Content-Disposition: attachment;\n filename=\"".$this->GetFileName($datei)."\"\n\n";

				// Daten der Datei einlesen, in das BASE64 Format formatieren und auf max 72 Zeichen pro Zeile = transcodage BASE64 et formatage 72 caractres par ligne
				// aufteilen
				$file['inhalt'] = fread(fopen($datei,"rb"),filesize($datei));
				$file['inhalt'] = base64_encode($file['inhalt']);
				$file['inhalt'] = chunk_split($file['inhalt'],72);

				// Attachment mit Header in der Klassenvariable speichern = intgration de la mise en forme dans la variable idoine
				$this->attachment[] = $attachment_header.$file['inhalt']."\n";
			}
			else
			{
				echo "Die Datei $datei existiert nicht...Ce document $datei n'existe pas\n";
			}
		}

		// Funktion die den Dateinamen aus einer Angabe mit Pfad herausfiltert = traitement de l'adresse absolue du fichier
		function GetFileName($PathWithFile)
		{
			if(preg_match("/\//i",$PathWithFile))
			{
				return substr(strrchr($PathWithFile,"/"),1);
			}
			else
			{
				return $PathWithFile;
			}
		}

		// Funktion zum erstellen des Kompletten Headers der Email = mise en forme du Header des E-mail
		// Senden der Email = expdition des e-mail
		function send()
		{
			$this->makeMimeMail();

			$header = $this->emailheader;

			// berprfen ob Attachments angehngt wurden = ajout des diffrents attachements pris en compte
			if(count($this->attachment)>0)
			{
			//	$header .= 	"Content-Type: multipart/mixed;\n\tboundary=\"".$this->emailboundary."\"\n";
				$header .= "--".$this->emailboundary."\n";
				$header .= $this->textheader;

				if(count($this->attachment) > 0) $header .= implode("",$this->attachment);

				$header .= "--$this->emailboundary--";
			}
			else
			{
				$header .= $this->textheader;
			}
			// Versenden der Mail = mise en expdition individuelles des mails
                        if(count($this->empfaenger) >0)
                        {
                                foreach($this->empfaenger as $pour)
                                {
                                mail("$pour",$this->betreff,"",$header,"$this->createur");
                        //echo "Versenden gemacht fur ".$pour."= envoi fait pour ".$pour."<br>";
                                }
                        }
                        else
                        {
                        mail("$this->empfaenger",$this->betreff,"",$header,"$this->createur");
                        //echo "Versenden gemacht fur ".$this->empfaenger."= envoi fait pour ".$this->empfaenger;
                        }

			$this->deletememory();
		}

		// Diese Funktion ist nur zum testen = C'est une fonction en test
		function deletememory()
		{
			unset($this->to);
			unset($this->emailheader);
			unset($this->textheader);
			unset($this->attachment);
		}
	}
?>
